<?php 
get_header(); 
global $wp_query, $data;

// checks if the page is a store page
if(substr_count($_SERVER['REQUEST_URI'], sp_extract_url(get_option('product_list_url'))))
{
    $is_paged = true;
} else {
	$is_paged = false;	
}

?>
<?php
	if (($wp_query->is_single === true) || is_page(sp_extract_url(get_option('shopping_cart_url'))) || is_page(sp_extract_url(get_option('transact_url')))) {
		$class = 'onecolumn';
		$sidebar = false;
	} elseif (is_page(sp_extract_url(get_option('product_list_url'))) || $is_paged == true) {
		if ( isset($data[THEME_SHORTNAME.'product_sidebar']) && $data[THEME_SHORTNAME.'product_sidebar'] == 'true') { 
			$sidebar = true;
			$class = 'product_sidebar';
			if (isset($data[THEME_SHORTNAME.'product_sidebar_orientation'])) {
				$orientation = $data[THEME_SHORTNAME.'product_sidebar_orientation'];
			} else {
				$orientation = 'right';	
			}
		} else {
			$class = 'onecolumn';
			$sidebar = false;	
		}
	} elseif (is_active_sidebar('sidebar-widget-area') == false) {
		$class = 'onecolumn';
		$sidebar = false;
	} else {
		$sidebar = true;	
	}
?>
		<div id="container" class="group <?php echo $class." ".$orientation; ?>">
			<div id="content" role="main">

<?php
	if ( have_posts() )
		the_post();
?>

			<h1 class="page-title">
<?php if ( is_day() ) : ?>
				<?php printf( __( 'Daily Archives: <span>%s</span>', 'sp' ), get_the_date() ); ?>
<?php elseif ( is_month() ) : ?>
				<?php printf( __( 'Monthly Archives: <span>%s</span>', 'sp' ), get_the_date( 'F Y' ) ); ?>
<?php elseif ( is_year() ) : ?>
				<?php printf( __( 'Yearly Archives: <span>%s</span>', 'sp' ), get_the_date( 'Y' ) ); ?>
<?php else : ?>
				<?php _e( 'Blog Archives', 'sp' ); ?>
<?php endif; ?>
			</h1>

<?php
	/* Since we called the_post() above, we need to
	 * rewind the loop back to the beginning that way
	 * we can run the loop properly, in full.
	 */
	rewind_posts();

	/* Run the loop for the archives page to output the posts.
	 * If you want to overload this in a child theme then include a file
	 * called loop-archive.php and that will be used instead.
	 */
	 get_template_part( 'loop', 'archive' );
?>

			</div><!-- #content -->
            <?php 
			if ($sidebar) {
				get_sidebar(); 
			} ?>
		</div><!-- #container -->

<?php get_footer(); ?>
