<?php 
get_header(); 
global $wp_query, $data;

// checks if the page is a store page
if(substr_count($_SERVER['REQUEST_URI'], sp_extract_url(get_option('product_list_url'))))
{
    $is_paged = true;
} else {
	$is_paged = false;	
}

?>
<?php
	if (($wp_query->is_single === true) || is_page(sp_extract_url(get_option('shopping_cart_url'))) || is_page(sp_extract_url(get_option('transact_url')))) {
		$class = 'onecolumn';
		$sidebar = false;
	} elseif (is_page(sp_extract_url(get_option('product_list_url'))) || $is_paged == true) {
		if ( isset($data[THEME_SHORTNAME.'product_sidebar']) && $data[THEME_SHORTNAME.'product_sidebar'] == 'true') { 
			$sidebar = true;
			$class = 'product_sidebar';
			if (isset($data[THEME_SHORTNAME.'product_sidebar_orientation'])) {
				$orientation = $data[THEME_SHORTNAME.'product_sidebar_orientation'];
			} else {
				$orientation = 'right';	
			}
		} else {
			$class = 'onecolumn';
			$sidebar = false;	
		}
	} elseif (is_active_sidebar('sidebar-widget-area') == false) {
		$class = 'onecolumn';
		$sidebar = false;
	} else {
		$sidebar = true;	
	}
?>
		<div id="container" class="group <?php echo $class." ".$orientation; ?>">
			<div id="content" role="main">

<?php
	/* Queue the first post, that way we know who
	 * the author is when we try to get their name,
	 * URL, description, avatar, etc.
	 *
	 * We reset this later so we can run the loop
	 * properly with a call to rewind_posts().
	 */
	if ( have_posts() )
		the_post();
?>

				<h1 class="page-title author"><?php printf( __( 'Author Archives: %s', 'sp' ), "<span class='vcard'><a class='url fn n' href='" . get_author_posts_url( get_the_author_meta( 'ID' ) ) . "' title='" . esc_attr( get_the_author() ) . "' rel='me'>" . get_the_author() . "</a></span>" ); ?></h1>

<?php
// If a user has filled out their description, show a bio on their entries.
if ( get_the_author_meta( 'description' ) ) : ?>
					<div id="entry-author-info">
						<div id="author-avatar">
							<?php echo get_avatar( get_the_author_meta( 'user_email' ), apply_filters( 'sp_author_bio_avatar_size', 60 ) ); ?>
						</div><!-- #author-avatar -->
						<div id="author-description">
							<h2><?php printf( __( 'About %s', 'sp' ), get_the_author() ); ?></h2>
							<?php the_author_meta( 'description' ); ?>
						</div><!-- #author-description	-->
					</div><!-- #entry-author-info -->
<?php endif; ?>

<?php
	/* Since we called the_post() above, we need to
	 * rewind the loop back to the beginning that way
	 * we can run the loop properly, in full.
	 */
	rewind_posts();

	/* Run the loop for the author archive page to output the authors posts
	 * If you want to overload this in a child theme then include a file
	 * called loop-author.php and that will be used instead.
	 */
	 get_template_part( 'loop', 'author' );
?>
			</div><!-- #content -->
            <?php 
			if ($sidebar) {
				get_sidebar(); 
			} ?>
		</div><!-- #container -->
<?php get_footer(); ?>
