<?php 
global $page, $paged, $data, $wp_query;
$fb_html = '';
if (isset($data[THEME_SHORTNAME.'facebook_opengraph']) && ($data[THEME_SHORTNAME.'facebook_opengraph'] == 'true') && ($wp_query->is_single === true)) { 
	$fb_html = 'xmlns="http://www.w3.org/1999/xhtml" xmlns:og="http://ogp.me/ns#" xmlns:fb="http://www.facebook.com/2008/fbml"';
} ?>
<!DOCTYPE html>
<!--[if lt IE 7 ]> <html <?php language_attributes(); ?> class="no-js ie6"> <![endif]-->
<!--[if IE 7 ]>    <html <?php language_attributes(); ?> class="no-js ie7"> <![endif]-->
<!--[if IE 8 ]>    <html <?php language_attributes(); ?> class="no-js ie8"> <![endif]-->
<!--[if IE 9 ]>    <html <?php language_attributes(); ?> class="no-js ie9"> <![endif]-->
<!--[if (gt IE 9)|!(IE)]><!--> <html <?php language_attributes(); ?> class="no-js" <?php echo $fb_html; ?>> <!--<![endif]-->
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	global $page, $paged, $data;

	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		echo " | $site_description";

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'sp' ), max( $paged, $page ) );

	?></title>
<?php 
if (isset($data[THEME_SHORTNAME.'facebook_opengraph']) && ($data[THEME_SHORTNAME.'facebook_opengraph'] == 'true') && ($wp_query->is_single === true)) { 
while ( wpsc_have_products() ) : wpsc_the_product();
	$product_title = wpsc_the_product_title();
	$product_url = wpsc_the_product_permalink();
	$product_image_link = wpsc_the_product_image();
	$product_description = wpsc_the_product_description();
endwhile;
?>
<meta property="og:title" content="<?php echo $product_title; ?>" />
<meta property="og:type" content="<?php echo $data[THEME_SHORTNAME.'facebook_opengraph_type']; ?>" />
<meta property="og:url" content="<?php echo $product_url; ?>" />
<meta property="og:image" content="<?php echo $product_image_link; ?>" />
<meta property="og:site_name" content="<?php echo bloginfo('name'); ?>" />
<meta property="fb:admins" content="<?php echo $data[THEME_SHORTNAME.'facebook_opengraph_admin_id']; ?>" />
<meta property="fb:app_id" content="<?php echo $data[THEME_SHORTNAME.'facebook_opengraph_app_id']; ?>" /> 
<meta property="og:description" content="<?php echo strip_tags($product_description); ?>" />    
<?php } ?>    
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />

<!--FAVICON-->
<?php // check to see if favicon is set 
	$upload_dir = wp_upload_dir();
	if (isset($data[THEME_SHORTNAME.'favicon']) && $data[THEME_SHORTNAME.'favicon'] != '') : ?>
<link rel="icon" type="image/x-icon" href="<?php echo $data[THEME_SHORTNAME.'favicon']; ?>" />
	<?php else : ?>
<link rel="icon" type="image/x-icon" href="<?php echo get_template_directory_uri(); ?>/images/favicon.ico" />
<?php endif; ?>
<!--END FAVICON-->
<?php wp_head(); ?>
<script type="text/javascript">var WPSC_CORE_IMAGES_URL = "<?php echo WPSC_CORE_IMAGES_URL; ?>";</script>
</head>

<body <?php body_class(); ?>>
<!--[if lte IE 7 ]><div style="background-color:yellow;color:#000;padding:10px;text-align:center;">IT APPEARS YOU'RE USING AN OLDER BROWSER. WE SUGGEST YOU UPGRADE TO INTERNET EXPLORER 8 OR HIGHER.</div><![endif]-->
	<div id="top_wrapper" class="group">
    	<nav class="group">
			<?php /* if dynamic menu is not set, it fallbacks to wp_list_pages function */ ?>
            <?php wp_nav_menu( array( 'container' => 'false', 'fallback_cb' => 'header_menu', 'theme_location' => 'header', 'before' => '<span class="before">&nbsp;</span>') ); ?>
            <!--HEADER CART-->
            <div id="header_cart">
            	<a href="<?php echo get_option('shopping_cart_url'); ?>" title="<?php _e('Checkout', 'sp'); ?>" class="cart_icon" onClick="return false">
                    <span class="icon"></span>
                    
                    <em class="count">
                        <?php if (function_exists('wpsc_cart_item_count')) { 
                            if (wpsc_cart_item_count() == 0 || isset($_GET['sessionid'])) { 
                                echo "0";
                            } else { 
                                echo wpsc_cart_item_count(); 
                            } 
                        } ?>
                    </em></a>
            	<div id="cartContents">
                    <div class="shopping-cart-wrapper">
                    <?php if (function_exists('wpsc_cart_item_count')) { 
							get_template_part('wpsc','cart_widget'); 
						  } ?>
                    </div>
                </div><!--close cartContents-->                    
            </div><!--close header_cart-->
            <!--END HEADER CART-->                    
            	<a href="<?php echo get_option('user_account_url'); ?>" title="<?php _e('My Account', 'sp'); ?>" class="account_icon"><?php _e('Account', 'sp'); ?></a>
                <?php if(is_user_logged_in()) : ?>
				<a href="<?php echo wp_logout_url( get_permalink() ); ?>" title="<?php _e('Logout', 'sp'); ?>" class="account_logout"><?php _e('(Logout)', 'sp'); ?>                
                <img title="Loading" alt="Loading" src="<?php echo get_template_directory_uri(); ?>/images/ajax-loader.gif" class="header-logout-loading" />
                </a>
                <?php endif; ?>
                <div id="search_tab">
                	<?php get_search_form(); ?>
                	<span class="tab">Tab</span>
                </div><!--close search_tab-->
    	</nav>
    </div><!--close top_wrapper-->
    
<div id="wrapper" class="hfeed">
	<header class="group">
            <!--LOGO-->
            <a href="<?php echo home_url(); ?>" title="<?php _e($data[THEME_SHORTNAME.'logo_alt_text'],'sp'); ?>" id="logo">
            <?php if (isset($data[THEME_SHORTNAME.'site_logo_image_text']) && $data[THEME_SHORTNAME.'site_logo_image_text'] == 'image') :
            			if (isset($data[THEME_SHORTNAME.'logo_image']) && $data[THEME_SHORTNAME.'logo_image'] != '') {
							echo '<img src="'.$data[THEME_SHORTNAME.'logo_image'].'" alt="'.__($data[THEME_SHORTNAME.'logo_alt_text'],'sp').'" />';
						} else {
							if (isset($data[THEME_SHORTNAME.'skins']) && $data[THEME_SHORTNAME.'skins'] == '1') {
								echo '<img src="'.get_template_directory_uri().'/images/logo.png" alt="'.__($data[THEME_SHORTNAME.'logo_alt_text'],'sp').'" />';
							} else {
								echo '<img src="'.get_template_directory_uri().'/skins/images/skin'.$data[THEME_SHORTNAME.'skins'].'/logo.png" alt="'.__($data[THEME_SHORTNAME.'logo_alt_text'],'sp').'" />';
							}
						}
            	 elseif (isset($data[THEME_SHORTNAME.'site_logo_image_text']) && $data[THEME_SHORTNAME.'site_logo_image_text'] == 'text') : 
                		if (isset($data[THEME_SHORTNAME.'site_logo_text_title']) && $data[THEME_SHORTNAME.'site_logo_text_title'] != '') {
							_e($data[THEME_SHORTNAME.'site_logo_text_title'],'sp');
						} else {
							_e('Your Logo Here','sp');	
						}
				endif; ?>
            </a>
            <!--END LOGO-->
                <!--TAGLINE-->
                <?php if (isset($data[THEME_SHORTNAME.'tagline']) && $data[THEME_SHORTNAME.'tagline'] == 'true') : ?>
                <h1 id="tagline">
                    <?php __(bloginfo( 'description' ),'sp'); ?>
                </h1>
                <?php endif; ?>        
                <!--END TAGLINE-->
	</header>
