<?php 
get_header(); 
global $wp_query, $data;

// checks if the page is a store page
if(substr_count($_SERVER['REQUEST_URI'], sp_extract_url(get_option('product_list_url'))))
{
    $is_paged = true;
} else {
	$is_paged = false;	
}

?>
<?php
	if (($wp_query->is_single === true) || is_page(sp_extract_url(get_option('shopping_cart_url'))) || is_page(sp_extract_url(get_option('transact_url')))) {
		$class = 'onecolumn';
		$sidebar = false;
	} elseif (is_page(sp_extract_url(get_option('product_list_url'))) || $is_paged == true) {
		if ( isset($data[THEME_SHORTNAME.'product_sidebar']) && $data[THEME_SHORTNAME.'product_sidebar'] == 'true') { 
			$sidebar = true;
			$class = 'product_sidebar';
			if (isset($data[THEME_SHORTNAME.'product_sidebar_orientation'])) {
				$orientation = $data[THEME_SHORTNAME.'product_sidebar_orientation'];
			} else {
				$orientation = 'right';	
			}
		} else {
			$class = 'onecolumn';
			$sidebar = false;	
		}
	} elseif (is_active_sidebar('sidebar-widget-area') == false) {
		$class = 'onecolumn';
		$sidebar = false;
	} else {
		$sidebar = true;	
	}
?>
		<div id="container" class="group <?php echo $class." ".$orientation; ?>">
			<div id="content" role="main">
<?php if ( have_posts() ) : ?>
				<h1 class="page-title"><?php printf( __( 'Search Results for: %s', 'sp' ), '<span>' . get_search_query() . '</span>' ); ?></h1>
				<?php get_template_part( 'loop', 'search' ); ?>
<?php else : ?>
				<div id="post-0" class="post no-results not-found">
					<h2 class="entry-title"><?php _e( 'Nothing Found', 'sp' ); ?></h2>
					<div class="entry-content">
						<p><?php _e( 'Sorry, but nothing matched your search criteria. Please try again with some different keywords.', 'sp' ); ?></p>
						<?php get_search_form(); ?>
					</div><!-- .entry-content -->
				</div><!-- #post-0 -->
<?php endif; ?>
			</div><!--close content-->

            <?php 
			if ($sidebar) {
				get_sidebar(); 
			} ?>
		</div><!--close container-->
<?php get_footer(); ?>
