<?php
// displays also bought items
function sp_wpsc_also_bought( $product_id ) {
	/*
	 * Displays products that were bought aling with the product defined by $product_id
	 * most of it scarcely needs describing
	 */
	global $wpdb, $data;

	if ( get_option( 'wpsc_also_bought' ) == 0 ) {
		//returns nothing if this is off
		return '';
	}
	

	// to be made customiseable in a future release
	$also_bought_limit = 4;
	$element_widths = 96;
	$image_height = sp_themeInit('wpec_also_bought_image_size','height');
	$image_width = sp_themeInit('wpec_also_bought_image_size','width');
	$also_bought_crop = $data[THEME_SHORTNAME.'also_bought_crop'];
	$also_bought_zoomcrop = $data[THEME_SHORTNAME.'also_bought_zoomcrop'];
	$also_bought_compression = $data[THEME_SHORTNAME.'also_bought_compression'];
	
	$output = '';
	$also_bought = $wpdb->get_results( "SELECT `" . $wpdb->posts . "`.* FROM `" . WPSC_TABLE_ALSO_BOUGHT . "`, `" . $wpdb->posts . "` WHERE `selected_product`='" . $product_id . "' AND `" . WPSC_TABLE_ALSO_BOUGHT . "`.`associated_product` = `" . $wpdb->posts . "`.`id` AND `" . $wpdb->posts . "`.`post_status` IN('publish','protected') AND `" . $wpdb->posts . "`.`post_type` IN ('wpsc-product') ORDER BY `" . WPSC_TABLE_ALSO_BOUGHT . "`.`quantity` DESC LIMIT $also_bought_limit", ARRAY_A );
	if ( count( $also_bought ) > 0 ) {
		$output .= '<div class="wpsc_also_bought group">';
		if (isset($data[THEME_SHORTNAME.'cross_sales_title'])) {
			$cross_sales_title = $data[THEME_SHORTNAME.'cross_sales_title'];
		}
		$output .= '<h2>' . __( $cross_sales_title, 'sp' ) . "</h2>";		
		$output .= "<ul>";
		foreach ( (array)$also_bought as $also_bought_data ) {
			$output .= '<li class="wpsc_also_bought_item">';
			if ( get_option( 'show_thumbnails' ) == 1 ) {
				if ( wpsc_the_product_thumbnail(96,96,$also_bought_data['ID'])) {
					$output .= "<a href='" . get_permalink($also_bought_data['ID']) . "' class=''  rel='" . str_replace( " ", "_", get_the_title($also_bought_data['ID']) ) . "'>";
					$image_src = sp_wpsc_the_product_image($also_bought_data['ID']);
					$output .= '<img src="'.get_template_directory_uri().'/sp-framework/timthumb/timthumb.php?src='.$image_src.'&amp;h='.$image_height.'&amp;w='.$image_width.'&amp;zc='.$also_bought_zoomcrop.'&amp;q='.$also_bought_compression.'&amp;a='.$also_bought_crop.'" class="product_image">';
					$output .= "</a>";
				} else {
					if ( get_option( 'product_image_width' ) != '' ) {
						$output .= "<img src='" . WPSC_CORE_IMAGES_URL . "/no-image-uploaded.gif' title='" . get_the_title($also_bought_data['ID']) . "' alt='" . $also_bought_data['name'] . "' width='$image_display_height' height='$image_display_height' id='product_image_" . $also_bought_data['ID'] . "' class='product_image' />";
					} else {
						$output .= "<img src='" . WPSC_CORE_IMAGES_URL . "/no-image-uploaded.gif' title='" . get_the_title($also_bought_data['ID']) . "' alt='" . htmlentities( stripslashes( get_the_title($also_bought_data['ID']) ), ENT_QUOTES, 'UTF-8' ) . "' id='product_image_" . $also_bought_data['ID'] . "' class='product_image' />";
					}
				}
			}

			$output .= "<a class='wpsc_product_name' href='" . get_permalink($also_bought_data['ID']) . "'>" . get_the_title($also_bought_data['ID']) . "</a>";
			$price = get_product_meta($also_bought_data['ID'], 'price', true);
			$special_price = get_product_meta($also_bought_data['ID'], 'special_price', true);
			if(!empty($special_price)){
				$output .= '<span class="oldprice">' . wpsc_currency_display( $price ) . '</span>';
				$output .= wpsc_currency_display( $special_price );
			} else {
				$output .= wpsc_currency_display( $price );
			}
			$output .= "</li>";
		}
		$output .= "</ul>";
		$output .= "</div>";
	}
	return $output;
}
?>