<?php
/**
* SP FRAMEWORK FILE - DO NOT EDIT!
* 
* admin control panel
******************************************************************/

/**
* load admin css and scripts
*
******************************************************************/
if (is_admin()):
	add_action('init', 'sp_admin_css_javascripts');
endif;
function sp_admin_css_javascripts() {
	if ( isset( $_GET['page'] ) && $_GET['page'] == 'sp' ) {
		//add_thickbox();
		wp_enqueue_style( 'sp_admin_style', get_template_directory_uri().'/sp-framework/styles/admin.css');
		// enqueue colorpicker style
		wp_enqueue_style( 'sp_colopicker_style', get_template_directory_uri().'/sp-framework/colorpicker/css/colorpicker.css');
		// enqueue colorpicker style
		wp_enqueue_style( 'sp_uploadify_style', get_template_directory_uri().'/sp-framework/uploadify/uploadify.css');
		// enqueue colorpicker
		wp_enqueue_script( 'sp_colorpicker', get_template_directory_uri().'/sp-framework/colorpicker/js/colorpicker.js', array('jquery') );
		// enqueue jquery ui
		wp_enqueue_script( 'sp_jquery_ui', get_template_directory_uri().'/sp-framework/js/jquery-ui-1.8.11.custom.min.js', array('jquery') );
		// enqueue swfobject
		wp_enqueue_script( 'sp_swfobject', get_template_directory_uri().'/sp-framework/uploadify/swfobject.js', array('jquery') );
		// enqueue uploadify
		wp_enqueue_script( 'sp_uploadify', get_template_directory_uri().'/sp-framework/uploadify/jquery.uploadify.v2.1.4.min.js', array('jquery') );
		// enqueue admin scripts
		wp_enqueue_script( 'sp_admin_js', get_template_directory_uri().'/sp-framework/js/admin.js', array('jquery') );
		// localize a namespace for ajax functions
		wp_localize_script( 'sp_admin_js', 'sp_theme', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'ajax_custom_nonce' => wp_create_nonce('ajax_custom_nonce') ) );			
	}
}

/**
* admin menu
*
******************************************************************/
function sp_admin_menu() {
		global $themeinfo;		
		add_menu_page('sp', $themeinfo['Name'], 'manage_options', 'sp', 'sp_panel', get_template_directory_uri() .'/sp-framework/images/favicon.png',55);
		add_submenu_page('sp', $themeinfo['Name'], 'Theme Settings', 'manage_options', 'sp', 'sp_panel');			
}

/**
* admin panel
*
******************************************************************/
function sp_panel() { ?>
<script type="text/javascript">
	var framework_url = "<?php echo get_template_directory_uri(); ?>/sp-framework/", theme_url = "<?php echo get_template_directory_uri(); ?>/", site_url = "<?php echo home_url(); ?>/";
</script>
<?php
	global $wpdb, $themeinfo, $data, $sp_framework_version, $notification, $config;	 
	$data = get_data();
	?>
    <div class="wrap">
    	<div class="notification"><?php if (!isset($data[THEME_SHORTNAME.'hide_msg']) || $data[THEME_SHORTNAME.'hide_msg'] == '' || $data[THEME_SHORTNAME.'hide_msg'] == 'false' ){ echo $notification; } ?></div>
		<form method="post" enctype="multipart/form-data" class="main-form" id="sp-panel">	
			<div class="alert"></div>
        	<?php if (function_exists('wp_nonce_field')) wp_nonce_field('sp-theme-option-save'); ?>
            <?php if (function_exists('wp_nonce_field')) wp_nonce_field('sp-theme-option-reset'); ?>  
            <input type="hidden" name="action" value="save" />
            <div id="content">
            	<div id="header" class="group">
                	<div id="logo">
                    	<h1><?php echo $themeinfo['Name']; ?></h1><br />
                        <small>v<?php echo $themeinfo['Version']; ?></small>
                    </div><!--close logo-->
                    <div id="nav">
                        <ul id="tabs">
                            <li class="general"><a href="#general" title="General Settings">GENERAL<br /><span>settings</span></a></li>
                            <li class="styling"><a href="#styling" title="Styling Options">STYLING<br /><span>options</span></a></li>
                            <li class="wpec"><a href="#wpec" title="WPEC Settings">WPEC<br /><span>settings</span></a></li>
                            <li class="help"><a href="#help" title="Help">HELP?</a></li>
                        </ul><!--close tabs-->
                    </div><!--close nav-->
                    <div id="header-meta" class="group">
                    	<input name="save" type="submit" value="SAVE ALL" class="save" />
                        <small>SP Framework v<?php echo $sp_framework_version; ?></small>
                    </div><!--close header-meta-->
                </div><!--close header-->
                <div id="general" class="panel group">
                	<ul class="side-nav">
                    	<?php 
							foreach ($config['tab']['general']['panel'] as $panel) {
								echo '<li><a href="#general-'.a_clean($panel['_attr']['title']).'" title="">'.$panel['_attr']['title'].'</a></li>';	
							}
						?>
                    </ul><!--side-nav-->
                    
                    <?php
						foreach ($config['tab']['general']['panel'] as $panel) {
							echo '<div id="general-'.a_clean($panel['_attr']['title']).'" class="option">';
							if (is_array($panel['wrapper'])) {
								foreach ($panel['wrapper'] as $wrapper) {
										if (isset($wrapper['_attr']['title'])) {
											echo '<fieldset>'."\r\n";
											echo '<legend>'.$wrapper['_attr']['title'].'</legend>'."\r\n";
										}
										if (isset($wrapper['module'])) {
											if (is_array($wrapper['module'])) {
												foreach ($wrapper['module'] as $module) {
													if (isset($module['_attr'])) {
														if ($module['_attr']['type'] != '') {
															echo call_user_func('sp_'.$module['_attr']['type'],$module);
														}
													}
												} // end 3rd foreach loop
											}
										}
										
										if (isset($wrapper['_attr']['title'])) {
											echo '</fieldset>'."\r\n";
										}									
								} // end 2nd foreach loop
							}
							echo '</div><!--close option-->';
						} // end 1st foreach loop
					?>
                </div><!--close general-->
                
                <div id="styling" class="panel group">
                	<ul class="side-nav">
                    	<?php 
							foreach ($config['tab']['styling']['panel'] as $panel) {
								echo '<li><a href="#styling-'.a_clean($panel['_attr']['title']).'" title="">'.$panel['_attr']['title'].'</a></li>';	
							}
						?>
                    </ul><!--side-nav-->
                    
                    <?php
						foreach ($config['tab']['styling']['panel'] as $panel) {
							echo '<div id="styling-'.a_clean($panel['_attr']['title']).'" class="option">';
							if (is_array($panel['wrapper'])) {
								foreach ($panel['wrapper'] as $wrapper) {
										if (isset($wrapper['_attr']['title'])) {
											echo '<fieldset>'."\r\n";
											echo '<legend>'.$wrapper['_attr']['title'].'</legend>'."\r\n";
										}
										if (isset($wrapper['module'])) {
											if (is_array($wrapper['module'])) {
												foreach ($wrapper['module'] as $module) {
													if (isset($module['_attr'])) {
														if ($module['_attr']['type'] != '') {
															echo call_user_func('sp_'.$module['_attr']['type'],$module);
														}
													}
												} // end 3rd foreach loop
											}
										}
										
										if (isset($wrapper['_attr']['title'])) {
											echo '</fieldset>'."\r\n";
										}									
								} // end 2nd foreach loop
							}
							echo '</div><!--close option-->';
						} // end 1st foreach loop
					?>
                </div><!--close styling-->
                
                <div id="wpec" class="panel group">
                	<ul class="side-nav">
                    	<?php 
							foreach ($config['tab']['wpec']['panel'] as $panel) {
								echo '<li><a href="#wpec-'.a_clean($panel['_attr']['title']).'" title="">'.$panel['_attr']['title'].'</a></li>';	
							}
						?>
                    </ul><!--side-nav-->
                    
                    <?php
						foreach ($config['tab']['wpec']['panel'] as $panel) {
							echo '<div id="wpec-'.a_clean($panel['_attr']['title']).'" class="option">';
							if (is_array($panel['wrapper'])) {
								foreach ($panel['wrapper'] as $wrapper) {
										if (isset($wrapper['_attr']['title'])) {
											echo '<fieldset>'."\r\n";
											echo '<legend>'.$wrapper['_attr']['title'].'</legend>'."\r\n";
										}
										
										if (isset($wrapper['module'])) {
											if (is_array($wrapper['module'])) {
												foreach ($wrapper['module'] as $module) {
													if (isset($module['_attr']['type'])) {
														if ($module['_attr']['type'] != '') {
															echo call_user_func('sp_'.$module['_attr']['type'],$module);
														}
													}
												} // end 3rd foreach loop
											}
										}
										
										if (isset($wrapper['_attr']['title'])) {
											echo '</fieldset>'."\r\n";
										}									
								} // end 2nd foreach loop
							}
							echo '</div><!--close option-->';
						} // end 1st foreach loop
					?>
                </div><!--close wpec-->

                <div id="help" class="panel group">
                	<ul class="side-nav">
                    	<?php 
							foreach ($config['tab']['help']['panel'] as $panel) {
								if (isset($panel['_attr'])) {
									echo '<li><a href="#help-'.a_clean($panel['_attr']['title']).'" title="">'.$panel['_attr']['title'].'</a></li>';	
								}
							}
						?>
                    </ul><!--side-nav-->
                    
                    <?php
						foreach ($config['tab']['help']['panel'] as $panel) {
							if (isset($panel['_attr']['title'])) {
								echo '<div id="help-'.a_clean($panel['_attr']['title']).'" class="option">';
							}
							if (isset($panel['wrapper'])) {
								if (is_array($panel['wrapper'])) {							
									foreach ($panel['wrapper'] as $wrapper) {
											if (isset($wrapper['_attr']['title'])) {
												echo '<fieldset>'."\r\n";
												echo '<legend>'.$wrapper['_attr']['title'].'</legend>'."\r\n";
											}
											
											if (isset($wrapper['module'])) {
												if (is_array($wrapper['module'])) {
													foreach ($wrapper['module'] as $module) {
														if (isset($module['_attr']['type'])) {
															if ($module['_attr']['type'] != '') {
																echo call_user_func('sp_'.$module['_attr']['type'],$module);
															}
														}
													} // end 3rd foreach loop
												}
											}
											if (isset($wrapper['_attr']['title'])) {
												echo '<a href="http://splashingpixels.com" title="Splashing Pixels" target="_blank">For more support, please go to our site support forums.</a>';
												echo '</fieldset>'."\r\n";
											}		
									} // end 2nd foreach loop
								} 
							}
							if (isset($panel['_attr']['title'])) {
								echo '</div><!--close option-->';
							}
						} // end 1st foreach loop
					?>
                </div><!--close help-->
                
            </div><!--close content-->
            <div id="footer-meta" class="group">
            	<input name="save" type="submit" value="SAVE ALL" class="save" />
                <a href="http://splashingpixels.com" title="Splashing Pixels" target="_blank" class="logo-link">Splashing Pixels</a>
            </div><!--close footer-meta-->
        </form>
    </div><!--close wrap-->	
<?php
}

/**
* grab theme init settings
* 
*
******************************************************************/
function sp_themeInit($item = '', $option = '') {
	global $config;
	return $config['init'][$item]['_attr'][$option];
}

/**
* grab theme init settings to generate nav menu
* 
*
******************************************************************/

function sp_navMenus() {
	global $config;
	
	$menu = array();
	if (is_array($config['init']['nav_menu'])) {
		foreach ($config['init']['nav_menu'] as $nav) {
				$menu[$nav['_attr']['name']] = __($nav['_attr']['title'],'sp');	
		}
	}
	return $menu;
}

/**
* clean data array
*
******************************************************************/
function a_clean($string="") {
	$string = strtolower(str_replace(' ','-',$string));	
	return $string;
}

/**
* check theme/framework versions
*
******************************************************************/
function isSiteUp($domain)
       {
               //check, if a valid url is provided
               if(!filter_var($domain, FILTER_VALIDATE_URL))
               {
                       return false;
               }
				if (!function_exists('curl_init')) {
					return false;	
				}
               //initialize curl
               $curlInit = curl_init($domain);
               curl_setopt($curlInit,CURLOPT_CONNECTTIMEOUT,1);
               curl_setopt($curlInit,CURLOPT_HEADER,true);
               curl_setopt($curlInit,CURLOPT_NOBODY,true);
               curl_setopt($curlInit,CURLOPT_RETURNTRANSFER,true);

               //get response
               $response = curl_exec($curlInit);

               curl_close($curlInit);

               if ($response) return true;

               return false;
       }

function sp_check_version() {
	global $notification, $themeinfo, $sp_framework_version, $data;	
	$siteCheck = isSiteUp('http://splashingpixels.s3.amazonaws.com/versions.xml');
	
	if ($siteCheck) {
		$context = stream_context_create(array('http'=>array('timeout'=>2)));
		if ($handle = @fopen('http://splashingpixels.s3.amazonaws.com/versions.xml','r',false,$context)) {
			$versions = fread($handle, 1024);
			fclose($handle);
		} /*elseif (function_exists('curl_init')) {
			$ch = curl_init();
			curl_setopt ($ch, CURLOPT_URL, 'http://splashingpixels.com/versions/versions.xml');
			curl_setopt ($ch, CURLOPT_POST, 1);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
			$versions = curl_exec($ch);
			curl_close($ch);	
		}*/
	}
	
	if (isset($versions) && $versions != '') {
		$versions = xml2array($versions);	
	
		if (is_array($versions['versions'])) {
			foreach($versions['versions']['item'] as $item) {
				$cur = str_replace('.','',trim($item['value']));
				
				if ($item['_attr']['name'] == strtolower(trim($themeinfo['Name']))) {
					if (str_replace('.','',$themeinfo['Version']) < $cur) {
						$notification .= '<p class="update">'.__('There is a new version of your theme available ('.$item['value'].'). Please visit','sp').' <a href="http://splashingpixels.com/member-section/" title="Splashing Pixels" target="_blank">Splashing Pixels</a> to download. <a href="http://splashingpixels.com/versions/'.strtolower(trim($themeinfo['Name'])).'_changelog.txt" title="Theme Changelog" target="_blank">(ChangeLog)</a>(To disable this message permanently <a href="#" class="hide_msg" title="Hide Message">click here</a>)</p>';
					}
				}
				if ($item['_attr']['name'] == 'framework') {
					if (str_replace('.','',$sp_framework_version) < $cur) {
						$notification .= '<p class="update">'.__('There is a new version of SP Framework available ('.$item['value'].'). Please visit','sp').' <a href="http://splashingpixels.com/member-section/" title="Splashing Pixels" target="_blank">Splashing Pixels</a> to download. <a href="http://splashingpixels.com/versions/framework_changelog.txt" title="Theme Changelog" target="_blank">(ChangeLog)</a>  (To disable this message permanently <a href="#" class="hide_msg" title="Hide Message">click here</a>)</p>';
					}
				}
		
			}
		}
	}
}

/**
* xml2array() will convert the given XML text to an array in the XML structure.
* Link: http://www.bin-co.com/php/scripts/xml2array/
* Arguments : $contents - The XML text
* $get_attributes - 1 or 0. If this is 1 the function will get the attributes as well as the tag values - this results in a different array structure in the return value.
* Return: The parsed XML in an array form.

* although this is a brilliant script, it has problems parsing single element arrays (need to look into that)
******************************************************************/
function xml2array($contents, $get_attributes=1, $priority = 'attribute') {
    if(!$contents) return array();

    if(!function_exists('xml_parser_create')) {
        //print "'xml_parser_create()' function not found!";
        return array();
    }

    //Get the XML parser of PHP - PHP must have this module for the parser to work
    $parser = xml_parser_create('');
    xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8"); # http://minutillo.com/steve/weblog/2004/6/17/php-xml-and-character-encodings-a-tale-of-sadness-rage-and-data-loss
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, trim($contents), $xml_values);
    xml_parser_free($parser);

    if(!$xml_values) return;//Hmm...

    //Initializations
    $xml_array = array();
    $parents = array();
    $opened_tags = array();
    $arr = array();

    $current = &$xml_array; //Refference

    //Go through the tags.
    $repeated_tag_index = array();//Multiple tags with same name will be turned into an array
    foreach($xml_values as $data) {
        unset($attributes,$value);//Remove existing values, or there will be trouble

        //This command will extract these variables into the foreach scope
        // tag(string), type(string), level(int), attributes(array).
        extract($data);//We could use the array by itself, but this cooler.

        $result = array();
        $attributes_data = array();
        
        if(isset($value)) {
            if($priority == 'tag') $result = $value;
            else $result['value'] = $value; //Put the value in a assoc array if we are in the 'Attribute' mode
        }

        //Set the attributes too.
        if(isset($attributes) and $get_attributes) {
            foreach($attributes as $attr => $val) {
                if($priority == 'tag') $attributes_data[$attr] = $val;
                else $result['_attr'][$attr] = $val; //Set all the attributes in a array called 'attr'
            }
        }

        //See tag status and do the needed.
        if($type == "open") {//The starting of the tag '<tag>'
            $parent[$level-1] = &$current;
            if(!is_array($current) or (!in_array($tag, array_keys($current)))) { //Insert New tag
                $current[$tag] = $result;
                if($attributes_data) $current[$tag. '_attr'] = $attributes_data;
                $repeated_tag_index[$tag.'_'.$level] = 1;

                $current = &$current[$tag];

            } else { //There was another element with the same tag name

                if(isset($current[$tag][0])) {//If there is a 0th element it is already an array
                    $current[$tag][$repeated_tag_index[$tag.'_'.$level]] = $result;
                    $repeated_tag_index[$tag.'_'.$level]++;
                } else {//This section will make the value an array if multiple tags with the same name appear together
                    $current[$tag] = array($current[$tag],$result);//This will combine the existing item and the new item together to make an array
                    $repeated_tag_index[$tag.'_'.$level] = 2;
                    
                    if(isset($current[$tag.'_attr'])) { //The attribute of the last(0th) tag must be moved as well
                        $current[$tag]['0_attr'] = $current[$tag.'_attr'];
                        unset($current[$tag.'_attr']);
                    }

                }
                $last_item_index = $repeated_tag_index[$tag.'_'.$level]-1;
                $current = &$current[$tag][$last_item_index];
            }

        } elseif($type == "complete") { //Tags that ends in 1 line '<tag />'
            //See if the key is already taken.
            if(!isset($current[$tag])) { //New Key
                $current[$tag] = $result;
                $repeated_tag_index[$tag.'_'.$level] = 1;
                if($priority == 'tag' and $attributes_data) $current[$tag. '_attr'] = $attributes_data;


            } else { //If taken, put all things inside a list(array)
                if(isset($current[$tag][0]) and is_array($current[$tag])) {//If it is already an array...

                    // ...push the new element into that array.
                    $current[$tag][$repeated_tag_index[$tag.'_'.$level]] = $result;
                    
                    if($priority == 'tag' and $get_attributes and $attributes_data) {
                        $current[$tag][$repeated_tag_index[$tag.'_'.$level] . '_attr'] = $attributes_data;
                    }
                    $repeated_tag_index[$tag.'_'.$level]++;

                } else { //If it is not an array...
                    $current[$tag] = array($current[$tag],$result); //...Make it an array using using the existing value and the new value
                    $repeated_tag_index[$tag.'_'.$level] = 1;
                    if($priority == 'tag' and $get_attributes) {
                        if(isset($current[$tag.'_attr'])) { //The attribute of the last(0th) tag must be moved as well
                            
                            $current[$tag]['0_attr'] = $current[$tag.'_attr'];
                            unset($current[$tag.'_attr']);
                        }
                        
                        if($attributes_data) {
                            $current[$tag][$repeated_tag_index[$tag.'_'.$level] . '_attr'] = $attributes_data;
                        }
                    }
                    $repeated_tag_index[$tag.'_'.$level]++; //0 and 1 index is already taken
                }
            }

        } elseif($type == 'close') { //End of tag '</tag>'
            $current = &$parent[$level-1];
        }
    }
    
    return($xml_array);
}  

/**
* check custom style module
*
******************************************************************/
if (!function_exists('sp_custom_styles')) {
function sp_custom_styles() {
	global $data, $config;
	$output = '';
	$font = '';
	if (isset($data[THEME_SHORTNAME.'skins']) && $data[THEME_SHORTNAME.'skins'] != '1' && $data[THEME_SHORTNAME.'skins'] != '') {
		$output .= "\r\n".'<link href="'.get_template_directory_uri() .'/skins/skin'.$data[THEME_SHORTNAME.'skins'].'.css" rel="stylesheet" type="text/css" />'."\r\n";
	}
	if (is_file(TEMPLATEPATH.'/custom_style.css')) {
		$output .= "\r\n".'<link href="'.get_template_directory_uri() .'/custom_style.css" rel="stylesheet" type="text/css" />'."\r\n";
	}
	$output .= '<style type="text/css">'."\r\n";
	// include theme widgets
	if (file_exists(TEMPLATEPATH. '/sp-dynamic.php')) {
		require_once(TEMPLATEPATH. '/sp-dynamic.php');
	}
	
	if (is_array($config['tab'])) {
		foreach ($config['tab'] as $tabs) {
			foreach ($tabs['panel'] as $panels) {
				if (isset($panels['wrapper'])) {
					if (is_array($panels['wrapper'])) {
						foreach ($panels['wrapper'] as $wrappers) {
							if (isset($wrappers['module'])) {
								if (is_array($wrappers['module'])) {
									foreach ($wrappers['module'] as $module) {
										if (isset($module['_attr']['property'])) {
											switch ($module['_attr']['property']) {
												case 'font-size' :
													if (isset($data[THEME_SHORTNAME.$module['_attr']['id']]) && $data[THEME_SHORTNAME.$module['_attr']['id']] != '') {
														$output .= $module['_attr']['handle'].' {'.$module['_attr']['property'].':'.$data[THEME_SHORTNAME.$module['_attr']['id']].'px;}';
													}
												break;
					
												case 'color' :
													if (isset($data[THEME_SHORTNAME.$module['_attr']['id']]) && $data[THEME_SHORTNAME.$module['_attr']['id']] != '') {							
														$output .= $module['_attr']['handle'].' {color:'.$data[THEME_SHORTNAME.$module['_attr']['id']].';}';
													}
												break;
												
												case 'text-hover' :
													if (isset($data[THEME_SHORTNAME.$module['_attr']['id']]) && $data[THEME_SHORTNAME.$module['_attr']['id']] != '') {							
														$output .= $module['_attr']['handle'].':hover {color:'.$data[THEME_SHORTNAME.$module['_attr']['id']].';}';
													}
												break;
												case 'font-weight' :
													if (isset($data[THEME_SHORTNAME.$module['_attr']['id']]) && $data[THEME_SHORTNAME.$module['_attr']['id']] != '0') {							
														$output .= $module['_attr']['handle'].' {'.$module['_attr']['property'].':'.$data[THEME_SHORTNAME.$module['_attr']['id']].';}';
													}
												break;
												
												case 'font-style' :
													if (isset($data[THEME_SHORTNAME.$module['_attr']['id']]) && $data[THEME_SHORTNAME.$module['_attr']['id']] != '0') {							
														$output .= $module['_attr']['handle'].' {'.$module['_attr']['property'].':'.$data[THEME_SHORTNAME.$module['_attr']['id']].';}';
													}
												break;
												
												case 'font-family' :
													if (isset($data[THEME_SHORTNAME.$module['_attr']['id']]) && $data[THEME_SHORTNAME.$module['_attr']['id']] != '0') {	
													$option = array('0','"Oswald"','"Pacifico"','"Anton"','"Copse"','"Cuprum"','"Josefin Slab"','"Yanone Kaffeesatz"','"Cabin"','"Alerta"','"Gruppo"');								
														$output .= $module['_attr']['handle'].' {'.$module['_attr']['property'].':'.$option[$data[THEME_SHORTNAME.$module['_attr']['id']]].',san-serif;}';
														$font .= '<link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family='.str_replace(array('"',' '),array('','+'),$option[$data[THEME_SHORTNAME.$module['_attr']['id']]]).'">'."\r\n";
													}
												break;
												default:
												break;	
											}
										}
				
									}
								}
							}
						}
					}
				}
			}			
		}
		
	}
	$output .= '</style>'."\r\n".$font;
	echo $output;
}
}
if (!is_admin()) {
	add_action('wp_head','sp_custom_styles');	
}

/**
* google analytics code insert
*
******************************************************************/
function sp_add_ga() {
	global $data;
	
	if (isset($data[THEME_SHORTNAME.'ga']) && $data[THEME_SHORTNAME.'ga'] != '') {
		echo $data[THEME_SHORTNAME.'ga']."\r\n";
	}
}
add_action('wp_head','sp_add_ga');

/**
* custom head scripts
*
******************************************************************/
function sp_custom_head_scripts() {
	global $data;
	
	if (isset($data[THEME_SHORTNAME.'custom_head_scripts']) && $data[THEME_SHORTNAME.'custom_head_scripts'] != '') {
		$output = '';
		$output .= '<script type="text/javascript">';
		$output .= $data[THEME_SHORTNAME.'custom_head_scripts'];
		$output .= '</script>'."\r\n";
		echo $output;
	}
}
add_action('wp_head','sp_custom_head_scripts');

/**
* custom footer scripts
*
******************************************************************/
function sp_custom_footer_scripts() {
	global $data;
	
	if (isset($data[THEME_SHORTNAME.'custom_footer_scripts']) && $data[THEME_SHORTNAME.'custom_footer_scripts'] != '') {
		$output = '';
		$output .= '<script type="text/javascript">';
		$output .= $data[THEME_SHORTNAME.'custom_footer_scripts'];
		$output .= '</script>'."\r\n";
		echo $output;
	}
}
add_action('wp_footer','sp_custom_footer_scripts');

/**
* if meta information set put in head
*
******************************************************************/
function sp_seo() {
	global $data;
	
	if (isset($data[THEME_SHORTNAME.'seo_keywords']) && $data[THEME_SHORTNAME.'seo_keywords'] != '') {
		echo "\r\n".'<meta name="keywords" content="'.$data[THEME_SHORTNAME.'seo_keywords'].'" />'."\r\n";
	}
	if (isset($data[THEME_SHORTNAME.'seo_description']) && $data[THEME_SHORTNAME.'seo_description'] != '') {
		echo "\r\n".'<meta name="description" content="'.$data[THEME_SHORTNAME.'seo_description'].' " />'."\r\n";
	}
}
add_action('wp_head','sp_seo');

/**
* add wpautop on/off to post/pages
*
******************************************************************/

add_action( 'add_meta_boxes', 'sp_custom_meta_boxes' );
add_action( 'save_post', 'sp_custom_meta_boxes_save' );

function sp_custom_meta_boxes() {
    add_meta_box( 
        'sp_custom_meta_box',
        __( 'Splashing Pixels WP Auto Formating', 'sp' ),
        'sp_custom_meta_box_display',
        'post' 
    );
    add_meta_box(
        'sp_custom_meta_box',
        __( 'Splashing Pixels WP Auto Formating', 'sp' ), 
        'sp_custom_meta_box_display',
        'page'
    );	
}

function sp_custom_meta_box_display($post) {
	wp_nonce_field( __FILE__ , 'sp_custom_meta_boxes_noncename' );	

	$checked = false;
	if ( $post->ID ) {
		$checked = get_post_meta($post->ID, 'sp_wpautop', true);
	}
	
	echo '<div class="inside"><label>Disable WP Auto Content Formatting: <input type="checkbox" value="1" name="sp_wpautop" id="sp_wpautop"'.(($checked) ? ' checked="checked"' : '').' /></label></div>';
	
}

function sp_custom_meta_boxes_save($post_id) {
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
		return;		
	
	if ( !wp_verify_nonce( $_POST['sp_custom_meta_boxes_noncename'], __FILE__  ) )
		return;		
	
	// Check permissions
	if ( 'page' == $_POST['post_type'] ) 
	{
	  if ( !current_user_can( 'edit_page', $post_id ) )
		  return;
	}
	else
	{
	  if ( !current_user_can( 'edit_post', $post_id ) )
		  return;
	}		
		 
	$spdata = (( $_POST['sp_wpautop'] == 1 ) ? true : false);
	if ( $spdata ) {
		update_post_meta($post_id, 'sp_wpautop', 1);
	} else {
		delete_post_meta($post_id, 'sp_wpautop');
	}	 
}

add_filter('the_content', 'wpautop_control_filter', 9);

function wpautop_control_filter($content) {
	global $post, $data;
	
	// Get the keys and values of the custom fields:
	$post_wpautop_value = get_post_meta($post->ID, 'sp_wpautop', true);
	
	if ( in_array($post_wpautop_value, array('true', '1')) )
	  $remove_filter = true;
	elseif ( in_array($post_wpautop_value, array('false', '0')) )
	  $remove_filter = false;
	else
	  $remove_filter = false;
	
	if ( $remove_filter ) {
	  remove_filter('the_content', 'wpautop');
	  remove_filter('the_excerpt', 'wpautop');
	}
	
	return $content;
}



/**
* load ajax actions
*
******************************************************************/
if (is_file(TEMPLATEPATH.'/sp-framework/sp-ajax.php')) {
	require_once(TEMPLATEPATH.'/sp-framework/sp-ajax.php');
}


/**
* runs after theme setup
*
******************************************************************/
add_action('after_setup_theme', 'sp_setup');
// function is run before init
if (!function_exists('sp_setup')) :

	function sp_setup() {
		// Make theme available for translation
		// Translations can be filed in the /languages/ directory
		load_theme_textdomain( 'sp', TEMPLATEPATH . '/languages' );
		$locale = get_locale();
		$locale_file = TEMPLATEPATH . "/languages/$locale.php";
		if (is_readable($locale_file ))
			require_once($locale_file);
		
		// add theme support menus
		if (function_exists('add_theme_support')) {
			// add menus
			add_theme_support( 'menus' );
			// Add default posts and comments RSS feed links to head
			add_theme_support('automatic-feed-links');
			// add post thumbnails
			add_theme_support( 'post-thumbnails' );
			// add post format since WP 3.1
			add_theme_support( 'post-formats', array( 'gallery' ) );
		}
		// Register custom dynamic menus
		register_nav_menus( sp_navMenus() );
		
		// removes the WP version from site
		function sp_remove_version() {
			return '';
		}
		add_filter('the_generator', 'sp_remove_version');

		// add in SP custom gravatar
		function newgravatar ($avatar_defaults) {
			$myavatar = get_template_directory_uri() . '/sp-framework/images/sp_gravatar.png';
			$avatar_defaults[$myavatar] = "Splashing Pixels";
			return $avatar_defaults;
		}
		add_filter('avatar_defaults', 'newgravatar');
		
		add_image_size('single_image', sp_themeInit('post_single_image_size','width'), sp_themeInit('post_single_image_size','height'), sp_themeInit('post_single_image_size','crop'));
		add_image_size('related_image', sp_themeInit('post_related_image_size','width'), sp_themeInit('post_related_image_size','height'), sp_themeInit('post_related_image_size','crop'));
		if ( ! isset( $content_width ) ) $content_width = 900;	
	}// end setup function
endif;
// run on activate
if (is_admin() && isset($_GET['activated'])){
	$themeinfo = get_theme_data(TEMPLATEPATH . '/style.css');
	if (!get_option($themeinfo['Name']."_sp_data") || get_option($themeinfo['Name']."_sp_data") == '') {
		add_action('init','sp_after_activate');
	}
	function sp_after_activate() {
		set_post_thumbnail_size(sp_themeInit('set_post_thumbnail_size','width'), sp_themeInit('set_post_thumbnail_size','height'), sp_themeInit('set_post_thumbnail_size','crop'));
		
	  // check if theme has been activated before
	  // set the default single product image size
	  update_option('single_view_image_height',sp_themeInit('wpec_single_view_image_size','height'));
	  update_option('single_view_image_width',sp_themeInit('wpec_single_view_image_size','width'));
	  update_option('product_image_height',sp_themeInit('wpec_product_image_size','height'));
	  update_option('product_image_width',sp_themeInit('wpec_product_image_size','width'));
	  update_option('wpsc_crop_thumbnails',sp_themeInit('wpec_image_crop','crop'));
	  
	  // set the default product gallery thumbnail size
	  update_option('wpsc_gallery_image_height',sp_themeInit('wpec_product_gallery_size','height'));
	  update_option('wpsc_gallery_image_width',sp_themeInit('wpec_product_gallery_size','width'));
	  
	  // set the default product group thumbnail size
	  update_option('category_image_height',sp_themeInit('wpec_product_category_size','height'));
	  update_option('category_image_width',sp_themeInit('wpec_product_category_size','width'));
	  
	  // set the default post thumbnail size
	  update_option('thumbnail_size_w',sp_themeInit('set_post_thumbnail_size','width'));
	  update_option('thumbnail_size_h',sp_themeInit('set_post_thumbnail_size','height'));
	  update_option('thumbnail_crop',sp_themeInit('set_post_thumbnail_size','crop'));
	  
	  // set the default WPEC pagination settings
	  update_option('use_pagination',sp_themeInit('wpec_pagination','enable'));
	  update_option('wpsc_products_per_page',sp_themeInit('wpec_pagination','per_page'));
	  update_option('wpsc_page_number_position',sp_themeInit('wpec_pagination','position'));
				  
	  // turn on add to cart for grid view
	  update_option("display_addtocart",sp_themeInit('wpec_gridview_addtocart','enable'));
	}
}

// removes gallery inline styles when using [gallery] shortcode.  Styles are in the CSS file where they should be.
function sp_remove_gallery_css($css) {
	return preg_replace("#<style type='text/css'>(.*?)</style>#s", '', $css);
}
add_filter('gallery_style', 'sp_remove_gallery_css');

// include template tags (includes shortcodes)
require_once(TEMPLATEPATH. '/sp-framework/sp-shortcodes-tags.php');

// include theme widgets
if (file_exists(TEMPLATEPATH. '/sp-widgets.php')) {
	require_once(TEMPLATEPATH. '/sp-widgets.php');
}

// include theme post enhancements
if (file_exists(TEMPLATEPATH. '/sp-posts-comments.php')) {
	require_once(TEMPLATEPATH. '/sp-posts-comments.php');
}

// include custom post type
if (file_exists(TEMPLATEPATH. '/sp-custom-post-type.php')) {
	require_once(TEMPLATEPATH. '/sp-custom-post-type.php');
}

// include menu template
if (file_exists(TEMPLATEPATH. '/sp-menu.php')) {
	require_once(TEMPLATEPATH. '/sp-menu.php');
}

// enqueue theme scripts
function sp_scripts() {
	global $themeinfo;
	if (is_ssl()) :
		$ssl_url = "https";
	else:
		$ssl_url = "http";
	endif;
		// comment out the next two lines to load the local copy of jQuery
		wp_deregister_script('jquery');
		wp_register_script('jquery', $ssl_url.'://ajax.googleapis.com/ajax/libs/jquery/1.7/jquery.min.js', '', '1.7',false);
		wp_enqueue_script('jquery');
		// enqueue modernizr script
		wp_register_script('modernizr', get_template_directory_uri().'/js/modernizr.min.js','','2.0.6',false);
		wp_enqueue_script('modernizr');
		// checks for theme specific js then load them
		if (file_exists(TEMPLATEPATH.'/sp-theme-js.php')) {
			require_once(TEMPLATEPATH.'/sp-theme-js.php');	
		}
		// enqueue pretty photo
		wp_register_script('pretty-photo', get_template_directory_uri() .'/js/jquery.prettyPhoto.js','','3.1.3',true);
		wp_enqueue_script('pretty-photo');			
		// enqueue theme JS
		wp_register_script('theme-js', get_template_directory_uri() .'/js/theme.min.js','',$themeinfo['Version'],true);
		wp_enqueue_script('theme-js');	
		// localize a namespace for ajax functions
		wp_localize_script( 'theme-js', 'sp_custom', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'ajax_custom_nonce' => wp_create_nonce('ajax_custom_nonce') ) );	
		// enqueue dynamic css
		//wp_register_style('sp_dynamic_css', home_url()."/index.php?sp_dynamic_css=true",false,THEME_VERSION, 'all');
		//wp_enqueue_style('sp_dynamic_css');
		
}

if (!is_admin()) {
	add_action('wp_print_scripts', 'sp_scripts');
}

// load theme/framework url into the head
function sp_site_url() {
	echo '<script type="text/javascript">';
	echo 'var framework_url = "'.get_template_directory_uri() .'/sp-framework/", theme_url = "'.get_template_directory_uri() .'/"';
	echo '</script>';
}

if (!is_admin()) {
	add_action('wp_head','sp_site_url');
}

// set the default WP settings for this theme when activated
if ( is_admin() && isset($_GET['activated'] ) && $pagenow == 'themes.php' ) {
	// setup permalinks
	update_option('permalink_structure','/%category%/%postname%/');
	
	// select default gravatar
	update_option('avatar_default',get_template_directory_uri() . '/sp-framework/images/sp_gravatar.png');
	
	// set to show avatars
	update_option('show_avatars','1');
	
	// create pages when theme is activated
	$new_page_title = 'SP Home';
	$new_page_content = 'Set your products here in the SP control panel or if this is a textarea, type your text in SP Home Page.';
	$new_page_template = 'sp_home.php'; //ex. template-custom.php. Leave blank if you don't want a custom page template.

	//don't change the code below, unless you know what you're doing

	$page_check = get_page_by_title($new_page_title);
	$new_page = array(
		'post_type' => 'page',
		'post_title' => $new_page_title,
		'post_content' => $new_page_content,
		'post_status' => 'publish',
		'post_author' => 1,
	);
	if(!isset($page_check->ID)){
		$new_page_id = wp_insert_post($new_page);
		if(!empty($new_page_template)){
			update_post_meta($new_page_id, '_wp_page_template', $new_page_template);
		}
	}
	// change show on front to page
	update_option('show_on_front','page');
	
	// change show on front page to home
	$page = get_page_by_title('sp home');
	update_option('page_on_front',$page->ID);
			
}

// deregister all wpec styles and consolidate in the main stylesheet
if (!is_admin()) {
	if (function_exists('wpsc_the_product')) {	
		add_action( 'wp_print_styles', 'sp_deregister_styles', 100 );
	}
}

function sp_deregister_styles() {
	wp_deregister_style('wpsc-thickbox');
	wp_deregister_style('wpsc-colorbox-css');
	wp_deregister_style('wpsc-theme-css');
	wp_deregister_style('wpsc-theme-css-compatibility');
	wp_deregister_style('wpsc-product-rater');
	wp_deregister_style('wp-e-commerce-dynamic');
	wp_deregister_style('wpsc-gold-cart-grid-view');
	wp_deregister_style('wpsc-gold-cart');

}

// remove gold cart styles
remove_action('wp_head','wpsc_grid_custom_styles',9);

// deregister all wpec scripts to move them to the footer where they belong
if (!is_admin()) {
	if (function_exists('wpsc_the_product')) {	
		add_action( 'wp_print_scripts', 'sp_deregister_javascript', 100 );
	}
}

function sp_deregister_javascript() {
	wp_deregister_script('wp-e-commerce');
	wp_deregister_script('infieldlabel');
	wp_deregister_script('wp-e-commerce-ajax-legacy');
	wp_deregister_script('wp-e-commerce-dynamic');
	wp_deregister_script('livequery');
	wp_deregister_script('jquery-rating');
	wp_deregister_script('wp-e-commerce-legacy');
	wp_deregister_script('wpsc-thickbox');	
	wp_deregister_script('colorbox-min');
	wp_deregister_script('wpsc_colorbox');
}

// register and enqueue the wpec scripts and put them in the footer
function sp_wpec_scripts() {
		$siteurl = get_option( 'siteurl' );
		if (is_ssl()) {
			$siteurl = str_replace( "http://", "https://", $siteurl );	
		}
		wp_register_script('sp_wp-e-commerce', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/wp-e-commerce.js','','3.8', true);
		wp_enqueue_script('sp_wp-e-commerce');

		//wp_register_script('sp_infieldlabel', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/jquery.infieldlabel.min.js','','3.8', true);
		//wp_enqueue_script('sp_infieldlabel');

		//wp_register_script('sp_wp-e-commerce-ajax-legacy', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/ajax.js','','3.8', true);
		//wp_enqueue_script('sp_wp-e-commerce-ajax-legacy');

		//wp_register_script('sp_wp-e-commerce-dynamic_js', $siteurl."/index.php?wpsc_user_dynamic_js=true",'','3.8', true);
		//wp_enqueue_script('sp_wp-e-commerce-dynamic_js');

		//=wp_register_script('sp_livequery', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-admin/js/jquery.livequery.js','','1.0.3', true);
		//wp_enqueue_script('sp_livequery');

		//wp_register_script('sp_jquery-rating', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/jquery.rating.js','','3.8', true);
		//wp_enqueue_script('sp_jquery-rating');

		//wp_register_script('sp_wp-e-commerce-legacy', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/user.js','','3.8', true);
		//wp_enqueue_script('sp_wp-e-commerce-legacy');

		/*$lightbox = get_option('wpsc_lightbox', 'thickbox');
		if( $lightbox == 'thickbox' ) {
			wp_register_script('sp_wpsc-thickbox', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/thickbox.js','','3.8', true);
			wp_enqueue_script('sp_wpsc-thickbox');
		} elseif( $lightbox == 'colorbox' ) {
			wp_register_script('sp_colorbox-min', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/jquery.colorbox-min.js','','3.8', true);
			wp_enqueue_script('sp_colorbox-min');
			wp_register_script('sp_wpsc_colorbox', WP_PLUGIN_URL. '/wp-e-commerce/wpsc-core/js/wpsc_colorbox.js','','3.8', true);
			wp_enqueue_script('sp_wpsc_colorbox');
		}*/
		wp_localize_script( 'sp_wp-e-commerce', 'wpsc_ajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
}
if (!is_admin()) {
	if (function_exists('wpsc_the_product')) {
		add_action('wp_print_scripts', 'sp_wpec_scripts');
	}
}

// set RSS url
function custom_feed_link($output, $feed) {
	global $data;
	$feed_url = $data[THEME_SHORTNAME.'rss_url'];
	$feed_array = array(
	'rss' => $feed_url,
	'rss2' => $feed_url,
	'atom' => $feed_url,
	'rdf' => $feed_url,
	'comments_rss2' => ''
	);
	$feed_array[$feed] = $feed_url;
	$output = $feed_array[$feed];
	return $output;
}

function other_feed_links($link) {
	global $data;
	$feed_url = $data[THEME_SHORTNAME.'rss_url'];
	return $link;
}

function custom_feed_links() {
	global $data;
	if (isset($data[THEME_SHORTNAME.'rss_url']) && $data[THEME_SHORTNAME.'rss_url'] != '') {
		add_filter('feed_link','custom_feed_link', 1, 2);
		add_filter('category_feed_link', 'other_feed_links');
		add_filter('author_feed_link', 'other_feed_links');
		add_filter('tag_feed_link','other_feed_links');
		add_filter('search_feed_link','other_feed_links');
		
	}
}
add_action('init','custom_feed_links');

// function to get url and strip down to page name
function sp_extract_url($url) {
	$last_slash_pos = strrpos($url,"/");
	$url = trim($url,"/");
	$url = substr($url,strrpos($url,"/")+1,$last_slash_pos);
	return $url;
}

// custom WP login
function sp_custom_login() { 
			global $data;
			$logo = '';
            if (isset($data[THEME_SHORTNAME.'site_logo_image_text']) && $data[THEME_SHORTNAME.'site_logo_image_text'] == 'image') :
            			if (isset($data[THEME_SHORTNAME.'logo_image']) && $data[THEME_SHORTNAME.'logo_image'] != '') {
							$logo = $data[THEME_SHORTNAME.'logo_image'];
						} else {
							if (isset($data[THEME_SHORTNAME.'skins']) && $data[THEME_SHORTNAME.'skins'] == '1') {
								$logo = get_template_directory_uri() .'/images/logo.png';
							} else {
								$logo = get_template_directory_uri() .'/skins/images/skin'.$data[THEME_SHORTNAME.'skins'].'/logo.png';
							}
						}
			endif;
	
	echo '<link rel="stylesheet" type="text/css" href="'.get_template_directory_uri() .'/sp-custom-login/sp-custom-login.css" />'; 
	echo '<style type="text/css">
		h1 a { background-image:url('.$logo.') !important; }

	</style>';
	
}
add_action('login_head', 'sp_custom_login');


require_once('sp-wp-login.php');
require_once('sp-wpec-functions.php');

// include also bought template
if (file_exists(TEMPLATEPATH. '/sp-also-bought.php')) {
	require_once(TEMPLATEPATH. '/sp-also-bought.php');
}

?>