<?php 
/**
* SP FRAMEWORK FILE - DO NOT EDIT!
* 
* shortcodes
******************************************************************/

// adds shortcode capability in widgets
add_filter('widget_text', 'do_shortcode');

// generate Google Plus 1 Button
// one argument passed in to determine the URL to be set to post or product or custom [sp_gplusone url=""]
function sp_gplusonebutton_shortcode($atts, $content = null) {
	if (is_ssl()) :
		$ssl_url = "https";
	else:
		$ssl_url = "http";
	endif;
	extract(shortcode_atts(array(  
         'url' => '',
		 'size' => '',
		 'count' => ''  
    ), $atts));  
		if ($atts['url'] == "post") :
			$url = urlencode(get_permalink());
		elseif ($atts['url'] == "product") :
			if (function_exists(wpsc_the_product_permalink)) :
				$url = urlencode(wpsc_the_product_permalink());
			else :
				$url = urlencode(get_permalink());
			endif;
		endif;
		if ($size == 'small') {
			$size = 'size="small"';
		} elseif ($size == 'medium') {
			$size = 'size="medium"';
		} elseif ($size == 'tall') {
			$size = 'size="tall"';	
		}
		if ($count == 'true') {
			$count = '';
		} elseif ($count == 'false') {
			$count = 'count="false"';	
		} else {
			$count = '';
		}
        $output = '<div class="gplusone">'."\r\n";
        $output .= '<g:plusone href="'.$url.'" '.$size.' '.$count.'></g:plusone>'; ?>
		<script type="text/javascript">
          (function() {
            var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
            po.src = 'https://apis.google.com/js/plusone.js';
            var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
          })();
        </script>		
        <?php $output .= "</div><!--close gplusone-->\r\n";
		return $output;
}
add_shortcode('sp_gplusone','sp_gplusonebutton_shortcode');

// generate FB Like button
// one argument passed in to determine the URL to be set to post or product or custom [sp_fblike url=""]
function sp_fblikebutton_shortcode($atts, $content = null) {
	if (is_ssl()) :
		$ssl_url = "https";
	else:
		$ssl_url = "http";
	endif;
	extract(shortcode_atts(array(  
         'url' => ''  
    ), $atts));  
		if ($atts['url'] == "post") :
			$url = urlencode(get_permalink());
		elseif ($atts['url'] == "product") :
			if (function_exists(wpsc_the_product_permalink)) :
				$url = urlencode(wpsc_the_product_permalink());
			else :
				$url = urlencode(get_permalink());
			endif;
		endif;
        $output = '<div class="fb-like" data-href="'.$url.'" data-send="false" data-layout="button_count" data-width="100" data-show-faces="false"></div>'."\r\n";
		return $output;
}
add_shortcode('sp_fblike','sp_fblikebutton_shortcode');

// generate Twitter Tweet button
function sp_tweetbutton_shortcode($atts, $content = null) {
	extract(shortcode_atts(array(  
         'url' => ''  
    ), $atts));  
		
		if ($url == "") :
			$url = get_permalink();
		endif;
		
		$output = '<div class="tweet_sc">'."\r\n";
		$output .= '<a href="http://twitter.com/share" class="twitter-share-button" data-url="'.$url.'" data-count="horizontal">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>';	
		$output .= '</div><!--close tweet_sc-->'."\r\n";
		
		return $output;
}
add_shortcode('sp_tweet','sp_tweetbutton_shortcode');

// shortcode to output the site root URL [sp_home_path]
function sp_home() {
	return home_url() . "/";
}
add_shortcode('sp_home_path', 'sp_home');

// shortcode to output the current theme URL [sp_theme_path]
function sp_theme() {
	return get_template_directory_uri() . "/";
}
add_shortcode('sp_theme_path', 'sp_theme');

// shortcode to easily add grid column layout in a post or blog
function sp_grid_system_narrow($atts, $content = null) {
	extract(shortcode_atts(array(
		'size' => false,
		'prefix' => false,
		'suffix' => false,
		'first' => false,
		'last' => false
	), $atts));

	if ($size) {
		$class = "narrow_grid_$size";
		if ($suffix) $class .= " narrow_suffix_$suffix";
		if ($prefix) $class .= " narrow_prefix_$prefix";
		if ($first) $class .= " narrow_alpha";
		if ($last) $class .= " narrow_omega";
	}
	else {
		$class = "";
		$last = true;
	}

	$output = "<div class=\"{$class}\"><p>". do_shortcode($content) ."</p></div>\n";
	if ($last) $output .= "<div class=\"group\"></div>\n";

	return $output;
}
add_shortcode('sp_grid6', 'sp_grid_system_narrow');
add_shortcode('sp_grid6a', 'sp_grid_system_narrow');
add_shortcode('sp_grid6b', 'sp_grid_system_narrow');

// shortcode to easily add grid column layout in a post or blog
function sp_grid_system_wide($atts, $content = null) {
	extract(shortcode_atts(array(
		'size' => false,
		'prefix' => false,
		'suffix' => false,
		'first' => false,
		'last' => false
	), $atts));

	if ($size) {
		$class = "wide_grid_$size";
		if ($suffix) $class .= " wide_suffix_$suffix";
		if ($prefix) $class .= " wide_prefix_$prefix";
		if ($first) $class .= " wide_alpha";
		if ($last) $class .= " wide_omega";
	}
	else {
		$class = "";
		$last = true;
	}

	$output = "<div class=\"{$class}\"><p>". do_shortcode($content) ."</p></div>\n";
	if ($last) $output .= "<div class=\"group\"></div>\n";

	return $output;
}
add_shortcode('sp_grid12', 'sp_grid_system_wide');
add_shortcode('sp_grid12a', 'sp_grid_system_wide');
add_shortcode('sp_grid12b', 'sp_grid_system_wide');

// change default WP image with caption containers to html5 figure tags
add_shortcode('wp_caption', 'sp_img_caption_shortcode');
add_shortcode('caption', 'sp_img_caption_shortcode');

function sp_img_caption_shortcode($attr, $content = null) {

extract(shortcode_atts(array(
'id'    => '',
'align'    => 'alignnone',
'width'    => '',
'caption' => ''
), $attr));

if ( 1 > (int) $width || empty($caption) )
return $content;

if ( $id ) $idtag = 'id="' . esc_attr($id) . '" ';

  return '<figure ' . $idtag . 'aria-describedby="figcaption_' . $id . '" class="'.$align.'">'
  . do_shortcode( $content ) . '<figcaption id="figcaption_' . $id . '">' . $caption . '</figcaption></figure>';
}

// shortcode to display a contact email link
function sp_contact_email_shortcode($atts, $content = null) {
	extract(shortcode_atts(array('email' => get_option('admin_email')), $atts));
	$output = '<a href="mailto:'.$email.'" title="'.$email.'">'.$email.'</a>';
	
	return $output;
	
}
add_shortcode('sp_email','sp_contact_email_shortcode');

//shortcode to display horizontal rule with optional colors
function sp_hr_shortcode($atts, $content = null) {
	extract(shortcode_atts(array('color' => '#ADA394'), $atts));
	$color = str_replace("#","",$color);
	$output = '<hr class="shortcode_line" style="border-color:#'.$color.';" />';
	
	return $output;
}
add_shortcode('sp_hr','sp_hr_shortcode');

// back to top shortcode
add_shortcode('sp_btt', 'sp_back_to_top');

function sp_back_to_top( $atts, $content = null ) {
	$output = '<div class="btt group"><a href="#top" title="Back to Top">Back to Top <span class="icon">&uarr;</span></a></div>';
	
	return $output;
}

// custom gallery shortcode
add_shortcode('gallery', 'sp_shortcode_gallery');

function sp_shortcode_gallery( $atts, $content = null ) {

	global $post, $wp_locale;
	extract(shortcode_atts(array(
		'order'		=> 'ASC',
		'orderby'	=> 'menu_order ID',
		'id'		=> $post->ID,
		'columns'	=> 5,
		'size'		=> 'thumbnail',
		'type'		=> '',
		'width'		=> '',
		'height'	=> '',
		'exclude'	=> ''
	), $atts));

	$exclude = preg_replace( '/[^0-9,]+/', '', $exclude );
	$attachments = get_children( array('post_parent' => $id, 'exclude' => $exclude, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	
	if ( empty($attachments) ) return '';

	$columns = intval($columns);
	$float = is_rtl() ? 'alignright' : 'alignleft';
	$w = $width ? "width='{$width}' " : '';
	$h = $height ? "height='{$height}' " : '';

	$i = 0; $output = '';
	foreach ( $attachments as $id => $attachment ) {

		$clear = false;
		$link = wp_get_attachment_image_src($id, $size, false);

		$output .= "
			<a class='{$type} lightbox preview_link' href='{$attachment->guid}' rel='prettyPhoto[{$post->ID}]' title='{$attachment->post_title}'>
				<img src='{$link[0]}' class='gallery {$float}' alt='{$attachment->post_title}' {$w}{$h}/>
			</a>";

		if ( $columns > 0 && ++$i % $columns == 0 ) {
			$output .= '<br class="group" />';
			$clear = true;
		}
	}

	if (!$clear) $output .= "<br class='group' />";

	return $output;
}

// color button shortcodes
add_shortcode('sp_button','sp_button_shortcode');
function sp_button_shortcode( $atts, $content = null ) {
	extract(shortcode_atts(array(
		'color' => 'default', 
		'url' => '#', 
		'target' => 'same', 
		'title' => '', 
		'position' => ''),$atts));
		
	$title = __($title,'sp');
	if ($target == 'same') {
		$target = '_self';
	} else {
		$target = '_blank';	
	}
	$custom_color = '';
	if (preg_match('/#/',$color)) {
		$custom_color = 'style="background:url('.get_template_directory_uri().'/images/button-overlay.png) repeat-x scroll center center '.$color.';"';	
		$color = '';
	} else {
		$color = strtolower($color);	
	}
	$output = '<a href="'.$url.'" title="'.$title.'" target="'.$target.'" class="button '.$color.' '.$position.'" '.$custom_color.'>'.$title.'</a>';
	
	return $output;
}

// pretty photo lightbox wrap shortcode
add_shortcode('sp_lightbox','sp_lightbox_shortcode');
function sp_lightbox_shortcode($atts, $content = null) {
	extract(shortcode_atts(array('title' => '', 'group' => '', 'url' => '', 'thumbnail' => '', 'theme' => '', 'slideshow' => '', 'show_social' => ''), $atts));
	$content = strip_tags($content,'<img>');
	if ($group == '') {
		$group = $url;	
	}
	if ($theme == '') {
		$theme = 'facebook';	
	}
	if ($slideshow == '') {
		$slideshow = 'false';	
	}
	if ($show_social == '') {
		$show_social == 'false';	
	}
	$source_url = parse_url($url);
	if ($source_url['host'] == 'www.youtube.com' || $source_url['host'] == 'youtube.com') {
		parse_str($source_url['query'], $query);
		if (isset($query['v']) && $query['v'] != '') {
			$id = $query['v'];
		} else {
		$path = explode("/",$source_url['path']);
		$id = $path[count($path)-1];
		}
		// if thumbnail is on, get first frame of video
		if ($thumbnail == "large" || $thumbnail == "small") {
			if ($thumbnail == "large") {
				$size = "hqdefault.jpg";
			} else {
				$size = "1.jpg";
			}
			$output = '<a href="'.$url.'" title="'.$title.'" rel="prettyPhoto['.$group.']" class="lightbox-wrap"><img src="http://img.youtube.com/vi/'.$id.'/'.$size.'" /></a>';
			$output .= '<input type="hidden" value="'.$theme.'" id="sc_lightbox_theme" />';
			$output .= '<input type="hidden" value="'.$slideshow.'" id="sc_lightbox_slideshow" />';
			$output .= '<input type="hidden" value="'.$show_social.'" id="sc_lightbox_show_social" />';	
		} else {
			$output = '<a href="'.$url.'" title="'.$title.'" rel="prettyPhoto['.$group.']" class="lightbox-wrap">'.do_shortcode($content).'</a>';	
			$output .= '<input type="hidden" value="'.$theme.'" id="sc_lightbox_theme" />';
			$output .= '<input type="hidden" value="'.$slideshow.'" id="sc_lightbox_slideshow" />';
			$output .= '<input type="hidden" value="'.$show_social.'" id="sc_lightbox_show_social" />';	

		}
	} elseif ($source_url['host'] == 'www.vimeo.com' || $source_url['host'] == 'vimeo.com' || $source_url['host'] == 'player.vimeo.com') {
		if (isset($query['clip_id']) && $query['clip_id'] != '') {
			$id = $query['clip_id'];
		} else {
			$path = explode("/",$source_url['path']);
			$id = $path[(count($path)-1)];
		}
		// if thumbnail is on, get first frame of video
		if ($thumbnail == "large" || $thumbnail == "small") {
			if (function_exists('file_get_contents')) {
				if ($thumbnail == "large") {
					$size = "thumbnail_large";
				} else {
					$size = "thumbnail_small";
				}				
				$hash = unserialize(file_get_contents("http://vimeo.com/api/v2/video/".$id.".php"));
				if (isset($hash[0]) && $hash[0] != '') {
					$image = $hash[0][$size];	
				}
			}
			$output = '<a href="'.$url.'" title="'.$title.'" rel="prettyPhoto['.$group.']" class="lightbox-wrap"><img src="'.$image.'" /></a>';	
			$output .= '<input type="hidden" value="'.$theme.'" id="sc_lightbox_theme" />';
			$output .= '<input type="hidden" value="'.$slideshow.'" id="sc_lightbox_slideshow" />';
			$output .= '<input type="hidden" value="'.$show_social.'" id="sc_lightbox_show_social" />';	

		} else {
			$output = '<a href="'.$url.'" title="'.$title.'" rel="prettyPhoto['.$group.']" class="lightbox-wrap">'.do_shortcode($content).'</a>';	
			$output .= '<input type="hidden" value="'.$theme.'" id="sc_lightbox_theme" />';
			$output .= '<input type="hidden" value="'.$slideshow.'" id="sc_lightbox_slideshow" />';
			$output .= '<input type="hidden" value="'.$show_social.'" id="sc_lightbox_show_social" />';	

		}		
	} else {
		$output = '<a href="'.$url.'" title="'.$title.'" rel="prettyPhoto['.$group.']" class="lightbox-wrap">'.do_shortcode($content).'</a>';
			$output .= '<input type="hidden" value="'.$theme.'" id="sc_lightbox_theme" />';
			$output .= '<input type="hidden" value="'.$slideshow.'" id="sc_lightbox_slideshow" />';
			$output .= '<input type="hidden" value="'.$show_social.'" id="sc_lightbox_show_social" />';	

	}
	return $output;
}

// display raw code shortcode
add_shortcode('sp_code', 'sp_shortcode_code');
function sp_shortcode_code( $atts, $content = null ) {
	$content = str_replace("</p>", "\n", $content);
	$content = str_replace("<p>", '', $content);
	$content = esc_attr($content);
	$content = str_replace("\n", "<br/>", trim($content));
	$content = preg_replace('/\[([^\]]*)\]/imu', '<strong>[</strong>$1<strong>]</strong>', $content);
	
	return "<code>". $content ."</code>\n";
}

// list shortcode
add_shortcode('sp_list','sp_list_shortcode');
function sp_list_shortcode($atts, $content = null) {
	extract(shortcode_atts(array(
		'type' => 'disc'
		),
		$atts));	
		$type = strtolower($type);
		switch($type) {
			case 'bullets': 
				$class = 'disc';
				break;
			
			case 'lower-alpha':
				$class = 'lower-alpha';
				break;
			
			case 'decimal':
				$class = 'decimal';
				break;
				
			case 'none':
				$class = 'none';
				break;
				
			case 'circle':
				$class = 'circle';
				break;
				
			case 'upper-alpha':
				$class = 'upper-alpha';
				break;
				
			case 'upper-roman':
				$class = 'upper-roman';
				break;
				
			case 'lower-roman':
				$class = 'lower-roman';
				break;
				
			case 'katakana':
				$class = 'katakana';
				break;
				
			default:
				$class = 'disc';
		}
		$content = strip_tags($content,'<strong><img>');
		$content = do_shortcode($content);
		$content = explode("~", $content);
		
		$output = '';
		$output .= '<ul class="list_sc '.$class.'">'."\r\n";
		foreach($content as $item) {
			$output .= '<li>'.$item.'</li>'."\r\n";
		}
		$output .= '</ul>'."\r\n";
		
		return $output;
		
}

// check user loggedin shortcode (if logged in, return content)
add_shortcode('sp_check_login','sp_check_login_shortcode');
function sp_check_login_shortcode($atts, $content = null) {
	if(is_user_logged_in()) {
		return do_shortcode($content);
	}
}

// blockquote shortcode
add_shortcode('sp_blockquote','sp_blockquote_shortcode');
function sp_blockquote_shortcode($atts, $content = null) {
	return '<blockquote>'.do_shortcode($content).'</blockquote>';
}

// display Google map shortcode
add_shortcode('sp_map', 'sp_google_map_shortcode');
function sp_google_map_shortcode($atts, $content = null) {
	extract(shortcode_atts(array('width' => '500px', 'height' => '300px', 'zoom' => 15, 'address' => '1600 Amphitheatre Parkway Mountain View, CA 94043'),$atts));
	$num = rand(0,10000);
	return '<script type="text/javascript">
		jQuery(function($) {
			initialize("'.$address.'",'.$num.','.$zoom.');
		});
		</script>
		<div id="sp_map_'.$num.'" style="display:block; width:'.$width.'; height:'.$height.';">&nbsp;</div>';
}

// function to add google map js script
function sp_google_map(){
	echo '<script type="text/javascript"
				src="http://maps.google.com/maps/api/js?sensor=false">
			</script>
			<script type="text/javascript">
			  function initialize(address, num, zoom) {
				var geo = new google.maps.Geocoder(),
				latlng = new google.maps.LatLng(-34.397, 150.644),
				myOptions = {
				  \'zoom\': zoom,
				  center: latlng,
				  mapTypeId: google.maps.MapTypeId.ROADMAP
				},
				map = new google.maps.Map(document.getElementById("sp_map_" + num), myOptions);
				
				geo.geocode( { \'address\': address}, function(results, status) {
				  if (status == google.maps.GeocoderStatus.OK) {
					map.setCenter(results[0].geometry.location);
					var marker = new google.maps.Marker({
						map: map, 
						position: results[0].geometry.location
					});
				  } else {
					// status
				  }
				});
			  }
			  </script>';
}
add_action('wp_footer','sp_google_map');
?>