<?php
/**
* SP FRAMEWORK FILE - DO NOT EDIT!
* 
* wpec overload functions
******************************************************************/

// get list of product data within specific category
/**
* function takes 2 parameters the category id and the count of items to return 	
*/ 
function sp_get_products($category_id, $count = '8', $random = true) {
	global $wpdb;
	if ($random == true) {
		$random = 'ORDER BY RAND()';
	} else {
		$random = '';	
	}
	$sql = "SELECT term_taxonomy_id FROM {$wpdb->prefix}term_taxonomy WHERE term_id = {$category_id}";
	$category_id = $wpdb->get_var($sql);	
	$sql = "SELECT object_id FROM {$wpdb->prefix}term_relationships WHERE term_taxonomy_id = {$category_id} {$random} LIMIT {$count}";
	$product_ids = $wpdb->get_results($sql);
	foreach ($product_ids as $product_id) {
		// check if it is published
		if (get_post_status($product_id->object_id) == 'publish') {
			$products[] = get_post($product_id->object_id);			
		}
	}
	// returns the products as stdClass Objects
	return $products;
}

//remove_action('template_redirect','wpsc_all_products_on_page');

// custom function to get the large product image and return timthumb magic
function sp_wpsc_the_product_image( $product_id='' ) {
	if ( empty( $product_id ) )
		$product_id = get_the_ID();
	$product = get_post( $product_id );

	if ( $product->post_parent > 0 )
		$product_id = $product->post_parent;

	$attached_images = (array)get_posts( array(
				'post_type' => 'attachment',
				'numberposts' => 1,
				'post_status' => null,
				'post_parent' => $product_id,
				'orderby' => 'menu_order',
				'order' => 'ASC'
			) );

	$attached_image = wp_get_attachment_image_src( $attached_images[0]->ID, 'full' );
	$image_src = $attached_image[0];
	return $image_src;
}

// remove "from" on pricing
function wpsc_remove_from_for_variations($from) {
	return '';
}
add_filter('wpsc_product_variation_text','wpsc_remove_from_for_variations');

// add WPEC body class to all shop pages
$products_page = get_option('product_list_url');
$products_page = substr($products_page,'0','-1');
$products_page = substr($products_page,strripos($products_page,"/")+1);  
if (strpos($_SERVER['REQUEST_URI'],$products_page) >= 1) {
	add_filter('body_class', 'wpsc');
	function wpsc($classes) {
	// add 'class-name' to the $classes array
	$classes[] = 'wpsc';
	// return the $classes array
	return $classes;
	}
}


// overload product description display content function
function sp_wpsc_the_product_description() {
	$content = get_the_content( __( 'More Info >', 'sp' ) );
	return wpautop($content,1);
}

// overload additional product description display content function
function sp_wpsc_the_product_additional_description() {
	global $post;

	if ( !empty( $post->post_excerpt ) )
		return wpautop($post->post_excerpt,1);
	else
		return false;
}

// load ajax functions to WP
if (is_admin()) :
	add_action('wp_ajax_nopriv_sp_add_to_cart', 'sp_add_to_cart');
	add_action('wp_ajax_sp_add_to_cart', 'sp_add_to_cart');
	add_action('wp_ajax_nopriv_sp_product_rate', 'sp_product_rate');
	add_action('wp_ajax_sp_product_rate', 'sp_product_rate');
endif;

// add to cart ajax function
function sp_add_to_cart() {
	$nonce = $_POST['ajax_custom_nonce'];
	if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	     die ('Busted!');
	}
	$count = wpsc_cart_item_count();
	if ($count == 0) {
		$count = 1;	
	}
	$total = wpsc_cart_total_widget();
	$response = array('count' => $count, 'total' => $total);
	echo json_encode($response);
	exit;
}

// product rate ajax function
function sp_product_rate() {
	global $wpdb;
	$nonce = $_POST['ajax_custom_nonce'];
	$rate = mysql_real_escape_string(trim($_POST['rate']));
	$id = mysql_real_escape_string(trim($_POST['id']));
	$ip = $_SERVER[REMOTE_ADDR];
	$current_time = time();
	if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	     die ('Busted!');
	}
	$sql = "SELECT COUNT(id) FROM {$wpdb->prefix}wpsc_product_rating WHERE ipnum = '$ip' AND productid = '$id'";
	$get_result = $wpdb->get_var($sql); 
	if ($get_result != 0) {
		$sql = "SELECT AVG(rated) FROM {$wpdb->prefix}wpsc_product_rating WHERE productid = '$id'";
		$current_rating = $wpdb->get_var($sql); 
		$current_rating = floor($current_rating);
		$response .= '<span class="star-rating-control">';
		for ($i = 1; $i < 6; $i++) {
				
			$checked = '';	
			if ($current_rating >= 1) {
				$checked = 'star-rating-on';
			}
			$response .= '<div class="star-rating rater-0 star star-rating-applied star-rating-readonly '.$checked.'">';
			$response .= '<a title="on">on</a></div>';
			$current_rating = $current_rating - 1;
		}
		
		$response .= '</span><p class="message">Sorry, you already rated!</p>';
		echo $response;
	} else {
		$sql = "INSERT INTO {$wpdb->prefix}wpsc_product_rating (ipnum,productid,rated,time) VALUES ('$ip','$id','$rate','$current_time')"; 
		$wpdb->query($sql);
		$sql = "SELECT AVG(rated) FROM {$wpdb->prefix}wpsc_product_rating WHERE productid = '$id'";
		$current_rating = $wpdb->get_var($sql); 
		$current_rating = floor($current_rating);
		$response .= '<span class="star-rating-control">';
		for ($i = 1; $i < 6; $i++) {
				
			$checked = '';	
			if ($current_rating >= 1) {
				$checked = 'star-rating-on';
			}
			$response .= '<div class="star-rating rater-0 star star-rating-applied star-rating-readonly '.$checked.'">';
			$response .= '<a title="on">on</a></div>';
			$current_rating = $current_rating - 1;
		}
			$response .= '</span><p class="message">Thanks for rating!</p>';		
		echo $response;
	}
	exit;
}

// displays html for star_rating
function sp_product_rating($product_id) {
	global $wpdb;
	$sql = "SELECT AVG(rated) FROM {$wpdb->prefix}wpsc_product_rating WHERE productid = '$product_id'";
	$current_rating = $wpdb->get_var($sql); 
	$current_rating = floor($current_rating);
	$output = '<div class="product_rating '.$product_id.'">';
	for ($i = 1; $i < 6; $i++) {	
		$checked = '';	
		if ($i == $current_rating) {
			$checked = 'checked="checked"';
		}
		$output .= '<input name="star'.$product_id.'" type="radio" class="star" '.$checked.' />';
	}
		$output .= '<input type="hidden" name="id" value="'.$product_id.'" />';
	$output .= '</div>';
	return $output;
}

function sp_wpsc_product_variation_price_available($product_id){
	global $wpdb;
	
	$sql = $wpdb->prepare( "
		SELECT pm.meta_value
		FROM {$wpdb->posts} AS p
		INNER JOIN {$wpdb->postmeta} AS pm ON pm.post_id = p.id AND pm.meta_key = '_wpsc_price'
		INNER JOIN {$wpdb->postmeta} AS pm2 ON pm2.post_id = p.id AND pm2.meta_key = '_wpsc_stock' AND pm2.meta_value != '0'
		WHERE
			p.post_type = 'wpsc-product'
			AND
			p.post_parent = %d
		ORDER BY CAST(pm.meta_value AS DECIMAL(10, 2)) ASC
		LIMIT 1
	", $product_id );

	$price = (float) $wpdb->get_var( $sql );
	
	$sql = $wpdb->prepare("
		SELECT pm.meta_value
		FROM {$wpdb->posts} AS p
		INNER JOIN {$wpdb->postmeta} AS pm ON pm.post_id = p.id AND pm.meta_key = '_wpsc_special_price' AND pm.meta_value != '0' AND pm.meta_value != ''
		INNER JOIN {$wpdb->postmeta} AS pm2 ON pm2.post_id = p.id AND pm2.meta_key = '_wpsc_stock' AND pm2.meta_value != '0'
		WHERE
			p.post_type = 'wpsc-product'
			AND
			p.post_parent = %d
		ORDER BY CAST(pm.meta_value AS DECIMAL(10, 2)) ASC
		LIMIT 1
	", $product_id);
	
	$special_price = (float) $wpdb->get_var( $sql );
	
	if ( ! empty( $special_price ) && $special_price < $price ) {
		$price = $special_price;
	}
	$price = wpsc_currency_display($price, array('display_as_html' => false));
	return $price;
}

function sp_check_variations($product_id){
	global $wpdb;
	
	$sql = $wpdb->prepare( "
		SELECT pm.meta_value
		FROM {$wpdb->posts} AS p
		INNER JOIN {$wpdb->postmeta} AS pm ON pm.post_id = p.id AND pm.meta_key = '_wpsc_price'
		INNER JOIN {$wpdb->postmeta} AS pm2 ON pm2.post_id = p.id AND pm2.meta_key = '_wpsc_stock' AND pm2.meta_value != '0'
		WHERE
			p.post_type = 'wpsc-product'
			AND
			p.post_parent = %d
		ORDER BY CAST(pm.meta_value AS DECIMAL(10, 2)) ASC
		LIMIT 1
	", $product_id );

	$price = (float) $wpdb->get_var( $sql );
	
	$sql = $wpdb->prepare("
		SELECT pm.meta_value
		FROM {$wpdb->posts} AS p
		INNER JOIN {$wpdb->postmeta} AS pm ON pm.post_id = p.id AND pm.meta_key = '_wpsc_special_price' AND pm.meta_value != '0' AND pm.meta_value != ''
		INNER JOIN {$wpdb->postmeta} AS pm2 ON pm2.post_id = p.id AND pm2.meta_key = '_wpsc_stock' AND pm2.meta_value != '0'
		WHERE
			p.post_type = 'wpsc-product'
			AND
			p.post_parent = %d
		ORDER BY CAST(pm.meta_value AS DECIMAL(10, 2)) ASC
		LIMIT 1
	", $product_id);
	
	$special_price = (float) $wpdb->get_var( $sql );
	
	if ( ! empty( $special_price ) && $special_price < $price ) {
		$price = $special_price;
	}
	return $price;
}

// checks if price is on special
function sp_wpsc_product_on_special($product_id = '') {
	global $wpsc_query, $wpdb;
	
	$price =  get_product_meta( $product_id, 'price', true );
	$sql = $wpdb->prepare( "
		SELECT pm.meta_value
		FROM {$wpdb->posts} AS p
		INNER JOIN {$wpdb->postmeta} AS pm ON pm.post_id = p.id AND pm.meta_key = '_wpsc_price'
		INNER JOIN {$wpdb->postmeta} AS pm2 ON pm2.post_id = p.id AND pm2.meta_key = '_wpsc_stock' AND pm2.meta_value != '0'
		WHERE
			p.post_type = 'wpsc-product'
			AND
			p.post_parent = %d
		ORDER BY CAST(pm.meta_value AS DECIMAL(10, 2)) ASC
		LIMIT 1
	", $product_id );

	$variation = $wpdb->get_var( $sql );
	// don't rely on product sales price if it has variations
	if ($variation != null ) {
		$sql = $wpdb->prepare("
			SELECT MIN(pm.meta_value)
			FROM {$wpdb->posts} AS p
			INNER JOIN {$wpdb->postmeta} AS pm ON pm.post_id = p.id AND pm.meta_key = '_wpsc_special_price' AND pm.meta_value != '0' AND pm.meta_value != ''
			INNER JOIN {$wpdb->postmeta} AS pm2 ON pm2.post_id = p.id AND pm2.meta_key = '_wpsc_stock' AND pm2.meta_value != '0'
			WHERE
				p.post_type = 'wpsc-product'
				AND
				p.post_parent = %d
			ORDER BY CAST(pm.meta_value AS DECIMAL(10, 2)) ASC
			LIMIT 1
		", $product_id );
		$special_price = (int) $wpdb->get_var( $sql );
	} else {
		$special_price = get_product_meta( $product_id, 'special_price', true );
	}

	if ( ($special_price > 0) && (($price - $special_price) > 0) )
		return true;
	else
		return false;

}

// displays the normal price
function sp_wpsc_product_normal_price($product_id = '',$forRSS = false) {
	global $wpsc_query, $wpdb, $wpsc_variations;
	if ( is_object($wpsc_variations) && count( $wpsc_variations->first_variations ) > 0 ) {
		//select the variation ID with lovest price
		$product_id = $wpdb->get_var('SELECT `posts`.`id` FROM ' . $wpdb->posts . ' `posts` JOIN ' . $wpdb->postmeta . ' `postmeta` ON `posts`.`id` = `postmeta`.`post_id` WHERE `posts`.`post_parent` = ' . $product_id . ' AND `posts`.`post_type` = "wpsc-product" AND `posts`.`post_status` = "inherit" AND `postmeta`.`meta_key`="_wpsc_price" ORDER BY (`postmeta`.`meta_value`)+0 ASC LIMIT 1');
		$from = ' from ';
	} else {
		$from = '';
	}
	$from = apply_filters('wpsc_product_variation_text',$from);
	$price = get_product_meta( $product_id, 'price', true );
	if($forRSS)
		$output = $from.wpsc_currency_display( $price, array( 'display_as_html' => false ) );
	else
		$output = $from.wpsc_currency_display( $price );
	return $output;
}

// displays products price
function sp_wpsc_the_product_price( $no_decimals = false, $product_id ) {
	global $wpsc_query, $wpsc_variations, $wpdb;
	$has_variation = '';
	$has_variation = sp_check_variations($product_id);
	if ( $has_variation != '0') {
		//select the variation ID with lowest price
		$output = sp_wpsc_product_variation_price_available($product_id);
		$from = ' from ';
	} else {
		$from = '';
		$full_price = get_post_meta( $product_id, '_wpsc_price', true );
		$special_price = get_post_meta( $product_id, '_wpsc_special_price', true );
		$price = $full_price;
		
		if ( ($full_price > $special_price) && ($special_price > 0) )
			$price = $special_price;
			
		if ( $no_decimals == true )
			$price = array_shift( explode( ".", $price ) );
		
		$args = array(
			'display_as_html' => false,
			'display_decimal_point' => !$no_decimals
		);	
		$output = wpsc_currency_display( $price,$args );
	}

	
	//if product has variations - add 'from'
	$from = apply_filters('wpsc_product_variation_text',$from);
	if ( isset($wpsc_variations->first_variations) && count( $wpsc_variations->first_variations ) > 0 && !empty($from))
		$output = sprintf(__(' from %s', 'sp'), $output);
		
	return $output;
}

// displays the fancy popup on add to cart
// first remove the current filter
remove_action('wpsc_theme_footer', 'wpsc_fancy_notifications');
remove_filter( 'the_content', 'add_to_cart_shortcode', 12 );
function sp_add_to_cart_shortcode( $content = '' ) {
	//exit($content);
	static $fancy_notification_output = false;
	if ( preg_match_all( "/\[add_to_cart=([\d]+)\]/", $content, $matches ) ) {
		foreach ( $matches[1] as $key => $product_id ) {
			$original_string = $matches[0][$key];
			$output = wpsc_add_to_cart_button( $product_id, true );
			$content = str_replace( $original_string, $output, $content );
		}
	}
	if ( ! $fancy_notification_output ) {
		//$content .= fancy_notifications();
		//$fancy_notification_output = true;
	}
	return $content;
}
add_filter( 'the_content', 'sp_add_to_cart_shortcode', 12 );
function sp_fancy_notifications() {
	$output = "";
	if ( get_option( 'fancy_notifications' ) == 1 ) {
		$output = "";
		$output .= "<div id='fancy_notification' class='group'>\n\r";
		$output .= "  <div id='loading_animation'>\n\r";
		$output .= '<img id="fancy_notificationimage" title="Loading" alt="Loading" src="'.get_template_directory_uri().'/images/ajax-loader.gif" />'."\n\r";
		$output .= "  </div>\n\r";
		$output .= "  <div id='fancy_notification_content' class='group'>\n\r";
		$output .= "  </div>\n\r";
		$output .= "</div>\n\r";
	}
	
	return $output;
}

// below 2 functions are overloaded to display a custom display template for the homepage
// Template tags
/**
 * wpsc display products function
 * @return string - html displaying one or more products
 */
function sp_wpsc_display_products_page( $query ) {
	global $wpdb, $wpsc_query, $wp_query;
	static $count = 0;
	$count++;
	remove_filter('the_title','wpsc_the_category_title');
	if ( $count > 10 )
		exit( 'fail' );

	// If the data is coming from a shortcode parse the values into the args variable, 
	// I did it this was to preserve backwards compatibility
	if(!empty($query)){	
		$args['post_type'] = 'wpsc-product';
		if(!empty($query['product_id']) && is_array($query['product_id'])){
			$args['post__in'] = $query['product_id'];
		}elseif(isset($query['product_id']) && is_string($query['product_id'])){
			$args['post__in'] = (array)$query['product_id'];
		}
		if(!empty($query['old_product_id'])){
			$post_id = wpsc_get_the_new_id($query['old_product_id']);
			$args['post__in'] = (array)$post_id;
		}
		if(!empty($query['price']) && 'sale' != $query['price']){
			$args['meta_key'] = '_wpsc_price';
			$args['meta_value'] = $query['price'];
		}elseif(!empty($query['price']) && 'sale' == $query['price']){
			$args['meta_key'] = '_wpsc_special_price';
			$args['meta_compare'] = '>=';
			$args['meta_value'] = '1';
		}
		if(!empty($query['product_name'])){
			$args['pagename'] = $query['product_name'];
		}
		if(!empty($query['category_id'])){

			$term = get_term($query['category_id'],'wpsc_product_category');
			$id = wpsc_get_meta($query['category_id'], 'category_id','wpsc_old_category');
			if( !empty($id)){
				$term = get_term($id,'wpsc_product_category');
				$args['wpsc_product_category'] = $term->slug;
				$args['wpsc_product_category__in'] = $term->term_id;
			}else{
				$args['wpsc_product_category'] = $term->slug;
				$args['wpsc_product_category__in'] = $term->term_id;
			}
		}
		if(!empty($query['category_url_name'])){
			$args['wpsc_product_category'] = $query['category_url_name'];
		}
		if(!empty($query['sort_order'])){
			$args['orderby'] = $query['sort_order'];
		}
		if(!empty($query['order'])){
			$args['order'] = $query['order'];
		}
		if(!empty($query['limit_of_items']) && '1' == get_option('use_pagination')){
			$args['posts_per_page'] = $query['limit_of_items'];
		}	
		if(!empty($query['number_per_page']) && '1' == get_option('use_pagination')){
			$args['posts_per_page'] = $query['number_per_page'];
		}
		if( '0' == get_option('use_pagination') ){
			$args['posts_per_page'] = $query['limit_of_items'];
		}
		if(!empty($query['tag'])){
			$args['product_tag'] = $query['tag'];
		}
	
		$temp_wpsc_query = new WP_Query($args);
	}
	// swap the wpsc_query objects
	list( $wp_query, $temp_wpsc_query ) = array( $temp_wpsc_query, $wp_query ); 
	$GLOBALS['nzshpcrt_activateshpcrt'] = true;
	$display_type = 'default';
	ob_start();
		sp_wpsc_include_products_page_template($display_type);
	$is_single = false;
	
	$output = ob_get_contents();
	ob_end_clean();
	$output = str_replace('\$','$', $output);
	list($temp_wpsc_query, $wp_query) = array( $wp_query, $temp_wpsc_query ); // swap the wpsc_query objects back
	if ( $is_single == false ) {
		$GLOBALS['post'] = $wp_query->post;
	} 
	return $output;
}

// return the custom homepage grid view
function sp_wpsc_include_products_page_template($display_type = 'default'){
	include( get_stylesheet_directory().'/home_sp_wpsc-grid_view.php' );	
}

// displays the grid view and default view options
if (!function_exists('sp_product_view')) :
	function sp_product_view() {
		global $data, $sp_view_mode;
		
		$_SERVER['REQUEST_URI'] = remove_query_arg( 'view_type' );
		$user_view = $sp_view_mode;
		$default = '';
		$grid = '';
		if ($user_view == 'default') {
			$default = 'active';
		} elseif ($user_view == 'grid') {
			$grid = 'active';	
		}
		$output = '<div class="product_views group"><div class="wrap">';
		$output .= '<a href="'.esc_url( add_query_arg( 'view_type', 'grid' ) ).'"  title="'.__( 'Grid View', 'sp' ).'" class="grid '.$grid.'">'.__( 'Grid', 'sp' ).'</a>';
		$output .= '<a href="'.esc_url( add_query_arg( 'view_type', 'default' ) ).'" title="'.__( 'Default View', 'sp' ).'" class="default '.$default.'">'.__( 'Default', 'sp' ).'</a>';		
		$output .= '</div><input type="hidden" name="view_type" value="'.esc_attr( $user_view ).'"></div>';
		return $output;
		
	}
endif;

// overload grid view
function sp_view_mode() {
		global $sp_view_mode, $data;
		
		$sp_view_mode = $data[THEME_SHORTNAME.'product_view'];
		
			if ( ! empty( $_REQUEST['view_type'] ) && in_array( $_REQUEST['view_type'], array( 'list', 'grid', 'default' ) ) )
				$sp_view_mode = $_REQUEST['view_type'];
			elseif ( ! empty( $_COOKIE['sp_view_mode_' . COOKIEHASH] ) )
				$sp_view_mode = $_COOKIE['sp_view_mode_' . COOKIEHASH];
			elseif ( ! empty( $_SESSION['wpsc_display_type'] ) )
				$sp_view_mode = $_SESSION['wpsc_display_type'];
			
			$sp_view_mode_cookie_lifetime = apply_filters( 'sp_view_mode_cookie_lifetime', 30000000 );
			setcookie('sp_view_mode_' . COOKIEHASH, $sp_view_mode, time() + $sp_view_mode_cookie_lifetime, COOKIEPATH, COOKIE_DOMAIN);
			$_SESSION['wpsc_display_type'] = $sp_view_mode;
		
	
}
if (get_option('show_search') != '1') {
	add_action( 'init', 'sp_view_mode' );
} else {
	if (get_option('show_advanced_search') != '1') {
		add_action( 'init', 'sp_view_mode' );
	}
}

// modified function to display product additional images in carousel slider	 
function sp_gold_shpcrt_display_gallery($product_id, $invisible = false, $numberposts = 3, $image_width, $image_height) {
	global $wpdb, $data, $wp_query;
	$output ='';
	$siteurl = get_option('siteurl');
	/* No GD? No gallery.	 No gallery option? No gallery.	 Range variable set?  Apparently, no gallery. */
	if ( !isset( $_GET['range'] ) && function_exists( "getimagesize" ) ) {
			$output = '';
			$product_name = get_the_title( $product_id );
			$output .= "<div class='cycler-gallery'><ul class='group'>";
			$args = array(
				'post_type'      => 'attachment',
				'post_parent'    => $product_id,
				'post_mime_type' => 'image',
				'orderby'        => 'menu_order',
				'order'          => 'ASC',
				'numberposts'    => $numberposts
			); 
			$attachments = get_posts($args);
			$image = '';
			if (count($attachments) > 1) {
				foreach ($attachments as $post) {
					setup_postdata($post);
					$image_src = wp_get_attachment_image_src( $post->ID, 'full');

					$cycler_mini_crop = $data[THEME_SHORTNAME.'cycler_mini_crop'];
					$cycler_mini_zoomcrop = $data[THEME_SHORTNAME.'cycler_mini_zoomcrop'];
					$cycler_mini_compression = $data[THEME_SHORTNAME.'cycler_mini_compression'];
					$image .= '<li>';
					$image .= '<img src="'.get_template_directory_uri().'/sp-framework/timthumb/timthumb.php?src=' . $image_src[0] . '&amp;h='.$image_height.'&amp;w='.$image_width.'&amp;zc='.$cycler_mini_zoomcrop.'&amp;q='.$cycler_mini_compression.'&amp;a='.$cycler_mini_crop.'" width="'.$image_width.'" height="'.$image_height.'" alt="'.$product_name.'" />';
					
				$image .= '</li>';
				} // close for loop
			}
			$output .= $image;
			$output .= "</ul></div>";
			wp_reset_query();
	} //closes if gallery setting condition
	return $output;
}

// allow category drag and drop order
add_action('admin_init', 'sp_admin_init'); 

function sp_admin_init () {

	remove_action( 'wp_ajax_category_sort_order', 'wpsc_ajax_set_category_order' );
	add_action( 'wp_ajax_category_sort_order', 'sp_wpsc_ajax_set_category_order' );

}

function sp_wpsc_ajax_set_category_order(){

  global $wpdb;
  $sort_order = $_POST['sort_order'];
  $parent_id  = $_POST['parent_id'];

  $result = true;
  foreach( $sort_order as $key=>$value ){

        // ignore empty value (bad javascript makes them)
  	if(!$value) continue;

  	$value = substr($value, strpos($value, '-')+1); // removes the "tag-" prefix from object id

    if( ! wpsc_update_meta( $value, 'sort_order', $key, 'wpsc_category' ) )
      $result = false;

  }

}


/*
remove_action('wpsc_theme_footer', 'wpsc_fancy_notifications');
function sp_fancy_notifications() {
	$output = "";
	if ( get_option( 'fancy_notifications' ) == 1 ) {
		$output = "";
		$output .= "<div id='fancy_notification' class='group'>\n\r";
		$output .= '<h2>'.__('Your Cart','sp').'</h2>';
		if(isset($cart_messages) && count($cart_messages) > 0) { 
			foreach((array)$cart_messages as $cart_message) {
			  $output .= '<span class="cart_message">'.$cart_message.'</span>';
			}
		 }
		
		if(wpsc_cart_item_count() > 0):
			$output .= '<div class="shoppingcart shopping-cart-wrapper">'."\r\n";
			$output .= '<table>';
				$output .= '<thead>';
					$output .= '<tr>';
						$output .= '<th id="product" colspan="4">'.__('Product', 'sp').'</th>';
						$output .= '<th id="quantity">'.__('Qty', 'sp').'</th>';
						$output .= '<th id="price">'.__('Price', 'sp').'</th>';
						$output .= '<th id="remove">&nbsp;</th>';
					$output .= '</tr>';
				$output .= '</thead>';
				$output .= '<tbody>';
				while(wpsc_have_cart_items()): wpsc_the_cart_item();
					$output .= '<tr>';
							$output .= '<td><img src="'.wpsc_cart_item_image().'" alt="'.wpsc_cart_item_name().'" title="'.wpsc_cart_item_name().'" class="product_image" /></td>';
							$output .= '<td colspan="4" class="product-name"><a href="'.wpsc_cart_item_url().'">'.wpsc_cart_item_name().'</a></td>';
							$output .= '<td>'.wpsc_cart_item_quantity().'</td>';
							$output .= '<td>'.wpsc_cart_item_price().'</td>';
							$output .= '<td class="cart-widget-remove"><form action="" method="post" class="adjustform">';
							$output .= '<input type="hidden" name="quantity" value="0" />';
							$output .= '<input type="hidden" name="key" value="'.wpsc_the_cart_item_key().'" />';
							$output .= '<input type="hidden" name="wpsc_update_quantity" value="true" />';
							$output .= '<input class="remove_button" type="submit" />';
						$output .= '</form></td>';
					$output .= '</tr>';
				endwhile;
				$output .= '</tbody>';
				$output .= '<tfoot>';
					if( ( wpsc_cart_has_shipping() && !wpsc_cart_show_plus_postage() ) || ( (wpsc_cart_tax(false) >0) && !wpsc_cart_show_plus_postage() ) ) :
					$output .= '<tr class="cart-widget-total cart-widget-shipping">';
						$output .= '<td class="pricedisplay checkout-shipping" colspan="5">';
							if(wpsc_cart_has_shipping() && !wpsc_cart_show_plus_postage()) : 
							$output .= __('Shipping', 'sp').': ' .wpsc_cart_shipping();
							endif;
							if( (wpsc_cart_tax(false) >0) && !wpsc_cart_show_plus_postage()) :
							$output .= '<br />';
							$output .= '<span class="pricedisplay checkout-tax">'.wpsc_display_tax_label(true).': '.wpsc_cart_tax().'</span>';
							endif;
						$output .= '</td>';
					$output .= '</tr>';
					endif; 
					$output .= '<tr class="cart-widget-total">';
						$output .= '<td class="cart-widget-count">';
							$output .= printf( _n('%d item', '%d items', wpsc_cart_item_count(), 'sp'), wpsc_cart_item_count() );
						$output .= '</td>';
						$output .= '<td class="pricedisplay checkout-total" colspan="4">';
							$output .= __('Total', 'sp').': '.wpsc_cart_total_widget();
						$output .= '</td>';
					$output .= '</tr>';
					if(wpsc_cart_show_plus_postage()) :
					$output .= '<tr>';
						$output .= '<td class="pluspostagetax" colspan="5">';
							$output .= '+ '.__('Postage &amp; Tax ', 'sp');
						$output .= '</td>';
					$output .= '</tr>';
					endif;
					$output .= '<tr>';
						$output .= '<td id="cart-widget-links" colspan="5">';
							$output .= '<a target="_parent" href="'.get_option('shopping_cart_url').'" title="'.__('Checkout', 'sp').'" class="gocheckout">'.__('Checkout', 'sp').'</a>';
							$output .= '<form action="" method="post" class="wpsc_empty_the_cart">';
								$output .= '<input type="hidden" name="wpsc_ajax_action" value="empty_cart" />';
									$output .= '<a target="_parent" href="'.htmlentities(add_query_arg('wpsc_ajax_action', 'empty_cart', remove_query_arg('ajax')), ENT_QUOTES, 'UTF-8').'" class="emptycart_ajax" title="'.__('Empty Your Cart', 'sp').'">'.__('Clear cart', 'sp').'</a>';
							$output .= '</form>';
						$output .= '</td>';
					$output .= '</tr>';
				$output .= '</tfoot>';
			$output .= '</table>';
			$output .= '</div><!--close shoppingcart-->';
		 else:
			$output .= '<p class="empty">';
				$output .= __('Your shopping cart is empty', 'sp').'<br />';
				$output .= '<a target="_parent" href="'.get_option('product_list_url').'" class="visitshop" title="Visit Shop">'.__('Visit the shop', 'sp').'</a>';	
			$output .= '</p>';
		endif;
		$output .= wpsc_google_checkout();

		$output .= "  <div id='loading_animation'>\n\r";
		$output .= '<img id="fancy_notificationimage" title="Loading" alt="Loading" src="'.get_template_directory_uri().'/images/ajax-loader.gif" />'."\n\r";
		$output .= "  </div>\n\r";
		//$output .= "  <div id='fancy_notification_content' class='group'>\n\r";
		//$output .= "  </div>\n\r";
		$output .= "</div>\n\r";
	}
	
	return $output;
}*/

?>